SystemOrganization addCategory: #Peldan!
SystemOrganization addCategory: 'Peldan-Collections'!
SystemOrganization addCategory: 'Peldan-PDF'!
SystemOrganization addCategory: 'Peldan-Test-PDF'!
SystemOrganization addCategory: 'Peldan-Text'!
SystemOrganization addCategory: 'Peldan-ToolBuilder-Morphic'!
SystemOrganization addCategory: 'Peldan-parsing'!

!String methodsFor: '*peldan-pdf' stamp: 'EP 3/3/2018 11:06'!
asPdfShowArgOn: aTarget 
	aTarget showText: self! !

!BlockClosure class methodsFor: '*peldan-sorting' stamp: 'EP 2/25/2018 15:16'!
compareByLength
	^ [:a :b | 
	a first isUppercase
		ifTrue: [false]
		ifFalse:[
	a size < b size
		or: [a size = b size
				and: [a asLowercase < b asLowercase]]]]! !

!Editor methodsFor: '*peldan-toolset' stamp: 'EP 2/28/2018 09:40'!
selectSomething
	self selection string = ''
		ifTrue: [self
				selectInterval: (self encompassWord: self selectionInterval)].! !

!Character class methodsFor: '*peldan-parsing' stamp: 'EP 2/21/2018 22:34'!
whitespace
	^ (Array
		with: Character cr
		with: Character space
		with: Character lf
		with: Character tab)! !

!Character methodsFor: '*peldan-testing' stamp: 'EP 2/21/2018 22:34'!
isWhitespace
	^ self class whitespace
		includes: self! !

!Point methodsFor: '*peldan-pdf' stamp: 'EP 3/3/2018 11:11'!
asPdfOffsetPoint
	^ self! !

!ByteArray methodsFor: '*peldan-pdf' stamp: 'EP 2/24/2018 12:50'!
inflated
	^ (ZLibReadStream on: self) contents! !

!ClassDescription methodsFor: '*peldan-compilation' stamp: 'EP 2/28/2018 21:53'!
synthesizeGetterFor: aFieldName
	"Compile a getter for the named field into this class"
	(self instVarNames includes: aFieldName)
		ifFalse: [self error: 'No such field. Add the field first'].
	self synthesizeGetterFor: aFieldName value: aFieldName.! !

!ClassDescription methodsFor: '*peldan-compilation' stamp: 'EP 2/28/2018 21:53'!
synthesizeGetterFor: aFieldName value: aValue
	"Compile a getter for the named field into this class"
	| getter |
	getter := aFieldName, Character cr asString, '  ^ ', aValue.
	getter := UIManager default request: 'Does this look OK?' initialAnswer: getter. 
	getter withBlanksTrimmed isEmpty
		ifFalse: 
	[self compile: getter classified: #accessing notifying: nil].! !

!ClassDescription methodsFor: '*peldan-compilation' stamp: 'EP 2/28/2018 21:54'!
synthesizeSetterFor: aFieldName
	"Compile a getter for the named field into this class"
	| setter |
	(self instVarNames includes: aFieldName)
		ifFalse: [self error: 'No such field. Add the field first'].
	setter := aFieldName, ': anObject', Character cr asString, '  ^ ', aFieldName, ' := anObject'.
	self compile: setter classified: #accessing notifying: nil.! !

!Class methodsFor: '*peldan-compilation' stamp: 'EP 2/28/2018 21:44'!
synthesizeGetterFor: aFieldName
	"Compile a getter for the named field into this class"
	(self instVarNames includes: aFieldName)
		ifFalse: [self error: 'No such field. Add the field first'].
	self synthesizeGetterFor: aFieldName value: aFieldName.! !

!Class methodsFor: '*peldan-compilation' stamp: 'EP 2/28/2018 21:48'!
synthesizeGetterFor: aFieldName value: aValue
	"Compile a getter for the named field into this class"
	| getter |
	getter := aFieldName, Character cr asString, '  ^ ', aValue.
	getter := UIManager default request: 'Does this look OK?' initialAnswer: getter. 
	getter withBlanksTrimmed isEmpty
		ifFalse: 
	[self compile: getter classified: #accessing notifying: nil].! !

!Class methodsFor: '*peldan-compilation' stamp: 'EP 2/28/2018 21:42'!
synthesizeSetterFor: aFieldName
	"Compile a getter for the named field into this class"
	| setter |
	(self instVarNames includes: aFieldName)
		ifFalse: [self error: 'No such field. Add the field first'].
	setter := aFieldName, ': anObject', Character cr asString, '  ^ ', aFieldName, ' := anObject'.
	self compile: setter classified: #accessing notifying: nil.! !

!Morph methodsFor: '*peldan-toolset-morphic' stamp: 'EP 2/25/2018 15:08'!
takeFocus
	World activeHand keyboardFocus: self! !

!Morph methodsFor: '*peldan-updating' stamp: 'EP 2/21/2018 19:58'!
update
	^ self ! !

!CharacterSet class methodsFor: '*peldan-pdf' stamp: 'EP 2/28/2018 13:56'!
newlines
	^ Array with: Character cr with: Character lf! !

TestCase subclass: #PDFCodeInterpreterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-PDF'!

!PDFCodeInterpreterTest methodsFor: 'as yet unclassified' stamp: 'EP 3/9/2018 22:38'!
testParseArguments
	| p r |
	p := PDFCodeInterpreter new.
	r := (p parseArguments: '1 0 0 1 -248.755 -79.601' readStream).
 	self assert:  r = #(1 0 0 1 -248.755 -79.601)! !

TestCase subclass: #PDFNumberParserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-Test-PDF'!

!PDFNumberParserTest methodsFor: 'as yet unclassified' stamp: 'EP 3/9/2018 22:03'!
testParseLeadingPoint
	| result |
	result := PDFNumberParser new parseObject: '.8' readStream.
	self assert: result = 0.8
	! !

!PDFNumberParserTest methodsFor: 'as yet unclassified' stamp: 'EP 3/9/2018 22:28'!
testParseNumberSequence
	| p s str |
	str := '1 0 0 1 -248.755 -79.601'.
	s := str readStream.
	p := PDFNumberParser new.
	self assert: (p parseObject: s) = 1.
	s maybeReadWhitespace.
	self assert: (p parseObject: s) = 0.
	s maybeReadWhitespace.
	self assert: (p parseObject: s) = 0.
	s maybeReadWhitespace.
	self assert: (p parseObject: s) = 1.
	s maybeReadWhitespace.
	self assert: (p parseObject: s) = -248.755.
	s maybeReadWhitespace.
	self assert: (p parseObject: s) = -79.601.
	! !

TestCase subclass: #PDFStringParserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-Test-PDF'!

!PDFStringParserTest methodsFor: 'as yet unclassified' stamp: 'EP 3/4/2018 15:20'!
testParseBackslash
	| result |
	result := PDFStringParser new parseObject: '(This has a single backslash \\)' readStream.
	self assert: result = 'This has a single backslash \'
	! !

!PDFStringParserTest methodsFor: 'as yet unclassified' stamp: 'EP 3/4/2018 14:58'!
testParseBalancedParentheses
	| result |
	result := PDFStringParser new parseObject: '(Strings may contain balanced parentheses ())' readStream.
	self assert: result = 'Strings may contain balanced parentheses ()'
	! !

!PDFStringParserTest methodsFor: 'as yet unclassified' stamp: 'EP 3/4/2018 14:58'!
testParseEmptyString
	| result |
	result := PDFStringParser new parseObject: '()' readStream.
	self assert: result isEmpty
	! !

!PDFStringParserTest methodsFor: 'as yet unclassified' stamp: 'EP 3/4/2018 14:57'!
testParseNewline
	| result |
	result := PDFStringParser new parseObject: '(Strings may contain
newlines and such.)' readStream.
	self assert: result = 'Strings may contain
newlines and such.'
	! !

!PDFStringParserTest methodsFor: 'as yet unclassified' stamp: 'EP 3/4/2018 15:24'!
testParseOctalEscape
	| result |
	result := PDFStringParser new parseObject: '(This string has an escape sequence:\040)' readStream.
	self assert: result = 'This string has an escape sequence: '
	! !

!PDFStringParserTest methodsFor: 'as yet unclassified' stamp: 'EP 3/8/2018 22:34'!
testParseOctalEscapeFollowedByDigit
	| result |
	result := PDFStringParser new parseObject: '(This string has an escape sequence:\0504)' readStream.
	self assert: result = 'This string has an escape sequence:(4'
	! !

!TextEditor methodsFor: '*peldan-toolset' stamp: 'EP 2/25/2018 15:53'!
encompassWord: anInterval 
	"Return an interval that encompasses the entire line"
	| string left right nonwordchars |
	string := paragraph text string.
	nonwordchars := Character whitespace
				, (Array
						with: $(
						with: $)
						with: $]
						with: $[
						with: $;
						with: $=), (Array with: $, with: $.).
	left := (string
				lastIndexOfAnyOf: nonwordchars
				startingAt: anInterval first - 1
				ifAbsent: [0])
				+ 1.
	right := (string
				indexOfAnyOf: nonwordchars
				startingAt: anInterval last + 1
				ifAbsent: [string size + 1])
				- 1.
	^ left to: right! !

!UndefinedObject methodsFor: '*peldan-parsing' stamp: 'EP 3/7/2018 21:32'!
run: aTarget 
	^ self! !

Object subclass: #DynamicListChooser
	instanceVariableNames: 'window listBlock selectedItems searchText searchMorph title listMorph index realIndex buttonBar builder addAllowed result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-ToolBuilder-Morphic'!

!DynamicListChooser commentStamp: '<historical>' prior: 0!
I am a simple dialog to allow the user to pick from a list of strings or symbols.
I support keyboard and mouse navigation, and interactive filtering of the displayed items.

You can specify whether you want the index, or the value of the selected item. If you're interested in the value, you can also allow users to Add a new value not in the list.

cmd-s or <enter> or double-click answers the currently selected item's value/index;
cmd-l or <escape> or closing the window answers nil/zero.

Now using ToolBuilder, so needs Morphic-MAD.381.

Released under the MIT Licence.!

!DynamicListChooser class methodsFor: 'instance creation' stamp: 'EP 2/28/2018 21:35'!
chooseClass
	| blk |
	blk := BlockClosure compareByLength.
	^ self
		chooseItemFrom: [:s | s size > 1
				ifTrue: [(Class classesWithNamesContaining: s)
						sorted: [:a :b | blk value: (a name) value: (b name)]]
				ifFalse: [#()]]
		title: 'Choose a class'! !

!DynamicListChooser class methodsFor: 'ChooserTool compatibility' stamp: 'EP 2/25/2018 14:06'!
chooseFrom: aList
	^ self 
		chooseFrom: aList 
		title: self defaultTitle! !

!DynamicListChooser class methodsFor: 'ChooserTool compatibility' stamp: 'EP 2/25/2018 14:06'!
chooseFrom: aList title: aString
	^ self
		chooseIndexFrom: aList 
		title: aString
		addAllowed: false! !

!DynamicListChooser class methodsFor: 'instance creation' stamp: 'EP 2/25/2018 14:06'!
chooseItemFrom: aList
	^ self 
		chooseItemFrom: aList 
		title: self defaultTitle! !

!DynamicListChooser class methodsFor: 'instance creation' stamp: 'EP 2/25/2018 14:16'!
chooseItemFrom: aList title: aString
	^ self new
		chooseItemFrom: aList 
		title: aString
		! !

!DynamicListChooser class methodsFor: 'instance creation' stamp: 'EP 2/25/2018 15:02'!
chooseItemFrom: aBlockClosure title: aString initial: aString3 
	^ self new
		chooseItemFrom: aBlockClosure
		title: aString
		initial: aString3! !

!DynamicListChooser class methodsFor: 'instance creation' stamp: 'EP 2/25/2018 14:20'!
chooseSelector
	^ self
		chooseItemFrom: [:s | s size > 2
				ifTrue: [(Symbol selectorsContaining: s)
						sorted: BlockClosure compareByLength]
				ifFalse: [#()]]
		title: 'Choose a selector'! !

!DynamicListChooser class methodsFor: 'instance creation' stamp: 'EP 2/25/2018 15:01'!
chooseSelector: aString 
	| inst |
	^ self
		chooseItemFrom: [:s | s size > 2
				ifTrue: [(Symbol selectorsContaining: s)
						sorted: BlockClosure compareByLength]
				ifFalse: [#()]]
		title: 'Choose a selector'
		initial: aString! !

!DynamicListChooser class methodsFor: 'instance creation' stamp: 'EP 2/25/2018 14:06'!
defaultTitle
	^ 'Please choose:'! !

!DynamicListChooser class methodsFor: 'utilities' stamp: 'EP 2/25/2018 14:47'!
selectorBlock
	^ [:s | s size > 2
				ifTrue: [(Symbol selectorsContaining: s)
						sorted: BlockClosure compareByLength]
				ifFalse: [#()]]! !

!DynamicListChooser methodsFor: 'event handling' stamp: 'EP 2/25/2018 14:06'!
accept
	"if the user submits with no valid entry, make them start over"
	self canAccept ifFalse: [ 	
		searchMorph selectAll.
		^ self ].
	
	"find the selected item in the original list, and return it"
	result := selectedItems at: index.

	builder ifNotNil: [ :bldr |
		builder := nil.
		bldr close: window ]! !

!DynamicListChooser methodsFor: 'drawing' stamp: 'EP 2/25/2018 14:06'!
acceptColor
	^ self canAccept 
		ifTrue: [ ColorTheme current okColor ]
		ifFalse: [ Color lightGray "ColorTheme current disabledColor <- you don't have this!!" ]! !

!DynamicListChooser methodsFor: 'event handling' stamp: 'EP 2/25/2018 14:06'!
acceptText: someText
	"the text morph wants to tell us about its contents but I don't care, I'm only interested in the list"
	self accept! !

!DynamicListChooser methodsFor: 'event handling' stamp: 'EP 2/25/2018 14:06'!
add
	"if the user submits with no valid entry, make them start over"
	self canAdd ifFalse: [ 	
		searchMorph selectAll.
		^ self ].
	
	"find the string to return"
	result := searchMorph getText.

	builder ifNotNil: [ :bldr |
		builder := nil.
		bldr close: window ]! !

!DynamicListChooser methodsFor: 'building' stamp: 'EP 2/25/2018 14:06'!
buildButtonBarWith: builder
	| panel button |
	panel := builder pluggablePanelSpec new
		model: self;
		layout: #proportional;
		children: OrderedCollection new.
	button := builder pluggableButtonSpec new.
	button
		model: self; 
		label: 'Accept (s)';
		action: #accept;
		enabled: #canAccept;
		state: #canAccept;
		color: #acceptColor;
		frame: (0.0 @ 0.0 corner: 0.34@1).
	panel children add: button.

	button := builder pluggableButtonSpec new.
	button
		model: self; 
		label: 'Add (a)';
		action: #add;
		enabled: #canAdd;
		frame: (0.36 @ 0.0 corner: 0.63@1).
	panel children add: button.

	button := builder pluggableButtonSpec new.
	button
		model: self; 
		label: 'Cancel (l)';
		action: #cancel;
		color: #cancelColor;
		frame: (0.65 @ 0.0 corner: 1@1).
	panel children add: button.
	
	^ panel! !

!DynamicListChooser methodsFor: 'building' stamp: 'EP 2/25/2018 14:06'!
buildListMorphWith: builder
	| listSpec |
	listSpec := builder pluggableListSpec new.
	listSpec 
		model: self;
		list: #list; 
		getIndex: #selectedIndex; 
		setIndex: #selectedIndex:; 
		doubleClick: #accept;
		"handleBasicKeys: false;"
		keystrokePreview: #keyStrokeFromList:;
		"doubleClickSelector: #accept;"
		autoDeselect: false.
	^ listSpec! !

!DynamicListChooser methodsFor: 'building' stamp: 'EP 2/25/2018 14:06'!
buildSearchMorphWith: builder
	| fieldSpec |
	fieldSpec := builder pluggableInputFieldSpec new.
	fieldSpec 
		model: self;
		getText: #searchText;
		setText: #acceptText:;
		menu: nil.
		"hideScrollBarsIndefinitely;"
		"acceptOnCR: true;"
		"setBalloonText: 'Type a string to filter down the listed items'."
		"onKeyStrokeSend: #keyStroke: to: self."
	^ fieldSpec! !

!DynamicListChooser methodsFor: 'building' stamp: 'EP 2/25/2018 14:06'!
buildWindowWith: builder
	| windowSpec |
	windowSpec := builder pluggableWindowSpec new.
	windowSpec model: self.
	windowSpec label: #title.
	windowSpec children: OrderedCollection new.
	^windowSpec! !

!DynamicListChooser methodsFor: 'building' stamp: 'EP 2/25/2018 14:06'!
buildWindowWith: builder specs: specs
	| windowSpec |
	windowSpec := self buildWindowWith: builder.
	specs do: [ :assoc |
		| rect action widgetSpec |
		rect := assoc key.
		action := assoc value.
		widgetSpec := action value.
		widgetSpec ifNotNil:[
			widgetSpec frame: rect.
			windowSpec children add: widgetSpec ] ].
	^ windowSpec! !

!DynamicListChooser methodsFor: 'building' stamp: 'EP 2/25/2018 14:06'!
buildWith: aBuilder
	| windowSpec searchBarHeight buttonBarHeight |
	builder := aBuilder.
	
	searchBarHeight := Preferences standardDefaultTextFont height * 2.
	buttonBarHeight := Preferences standardButtonFont height * 4.
	
	windowSpec := self buildWindowWith: builder specs: {
		(LayoutFrame fractions: (0@0 corner: 1@0) offsets: (0@0 corner: 0@searchBarHeight)) -> [self buildSearchMorphWith: builder].
		(LayoutFrame fractions: (0@0 corner: 1@1) offsets: (0@searchBarHeight corner: 0@buttonBarHeight negated)) -> [self buildListMorphWith: builder].
		(LayoutFrame fractions: (0@1 corner: 1@1) offsets: (0@buttonBarHeight negated corner: 0@0)) -> [self buildButtonBarWith: builder].
	}.
	windowSpec closeAction: #closed.
	windowSpec extent: self initialExtent.
	window := builder build: windowSpec.
	
	
	searchMorph := window submorphs detect: 
		[ :each | each isKindOf: PluggableTextMorph ].
	searchMorph
		hideScrollBarsIndefinitely;
		acceptOnCR: true;
		setBalloonText: 'Type a string to filter down the listed items';
		onKeyStrokeSend: #keyStroke: to: self;
		hasUnacceptedEdits: true "force acceptOnCR to work even with no text entered".
	listMorph := window submorphs detect: 
		[ :each | each isKindOf: PluggableListMorph ].
	^ window! !

!DynamicListChooser methodsFor: 'testing' stamp: 'EP 2/25/2018 14:06'!
canAccept
	^ self selectedIndex > 0! !

!DynamicListChooser methodsFor: 'testing' stamp: 'EP 2/25/2018 14:06'!
canAdd
	^ addAllowed and: [ self canAccept not ]! !

!DynamicListChooser methodsFor: 'event handling' stamp: 'EP 2/25/2018 14:06'!
cancel
	"Cancel the dialog and move on"
	index := 0.
	builder ifNotNil: [ builder close: window ]! !

!DynamicListChooser methodsFor: 'drawing' stamp: 'EP 2/25/2018 14:06'!
cancelColor
	^ ColorTheme current cancelColor! !

!DynamicListChooser methodsFor: 'initialize-release' stamp: 'EP 2/25/2018 14:59'!
chooseItemFrom: aBlockClosure title: aString 
	
	^ self chooseItemFrom: aBlockClosure title: aString initial: ''! !

!DynamicListChooser methodsFor: 'initialize-release' stamp: 'EP 2/25/2018 15:22'!
chooseItemFrom: aBlockClosure title: aString initial: aSearchString 
	listBlock := aBlockClosure.
	"coerce everything into an OC"
	builder := ToolBuilder default.
	self listBlock: listBlock.
	self title: aString.
	addAllowed := false.
	window := ToolBuilder default open: self.
	window center: Sensor cursorPoint.
	window setConstrainedPosition: Sensor cursorPoint - (window fullBounds extent // 2) hangOut: false.
	self searchText: aSearchString.
	self changed: #searchText.
	self updateFilter.
	"searchMorph selectAll."
	"searchMorph textMorph takeFocus."
	builder runModal: window.
	^ result! !

!DynamicListChooser methodsFor: 'event handling' stamp: 'EP 2/25/2018 14:06'!
closed
	"Cancel the dialog and move on"
	builder ifNotNil: [ index := 0 ]! !

!DynamicListChooser methodsFor: 'event handling' stamp: 'EP 2/25/2018 14:06'!
handlesKeyboard: evt
	^ true! !

!DynamicListChooser methodsFor: 'building' stamp: 'EP 2/25/2018 14:06'!
initialExtent
	| listFont titleFont buttonFont listWidth titleWidth buttonWidth |
	listFont := Preferences standardListFont.
	titleFont := Preferences windowTitleFont.
	buttonFont := Preferences standardButtonFont.
	listWidth := 20 * (listFont widthOf: $m).
	titleWidth := titleFont widthOfString: self title, '__________'. "add some space for titlebar icons"
	buttonWidth := buttonFont widthOfString: '_Accept_(s)___Add (a)___Cancel_(l)_'.
	^ (listWidth max: (titleWidth max: buttonWidth))@(30 * (listFont height))! !

!DynamicListChooser methodsFor: 'event handling' stamp: 'EP 2/25/2018 14:06'!
keyStroke: event
	| newText key |
	"handle updates to the search box interactively"
	key := event keyString.
	(key = '<up>') ifTrue: [ 
		self move: -1. 
		^ self ].
	(key = '<down>') ifTrue: [ 
		self move: 1.
		^ self ].

	(key = '<Cmd-s>') ifTrue: [ self accept. ^ self ].
	(key = '<cr>') ifTrue: [ self accept. ^ self ].

	(key = '<escape>') ifTrue: [ self cancel. ^ self ].
	(key = '<Cmd-l>') ifTrue: [ self cancel. ^ self ].
	
	(key = '<Cmd-a>') ifTrue: [ self add. ^ self ].

	"pull out what's been typed, and update the list as required"
	newText := searchMorph textMorph asText asString.
	(newText = searchText) ifFalse: [ 
		searchText := newText.
		self updateFilter ].
! !

!DynamicListChooser methodsFor: 'event handling' stamp: 'EP 2/25/2018 14:06'!
keyStrokeFromList: event
	"we don't want the list to be picking up events, excepting scroll events"

	"Don't sent ctrl-up/ctrl-down events to the searchMorph: they're scrolling events."
	(#(30 31) contains: [:each | each = event keyValue]) not
		ifTrue:
			["window world primaryHand keyboardFocus: searchMorph."
			searchMorph keyStroke: event.
			"let the list know we've dealt with it"
			^true].
	^false.
		! !

!DynamicListChooser methodsFor: 'accessing' stamp: 'EP 2/25/2018 14:06'!
list
	^ selectedItems! !

!DynamicListChooser methodsFor: 'accessing' stamp: 'EP 2/25/2018 14:11'!
listBlock
	^ listBlock! !

!DynamicListChooser methodsFor: 'accessing' stamp: 'EP 2/25/2018 14:11'!
listBlock: aBlockClosure 
	listBlock := aBlockClosure! !

!DynamicListChooser methodsFor: 'event handling' stamp: 'EP 2/25/2018 14:06'!
move: offset
	| newindex |
	"The up arrow key moves the cursor, and it seems impossible to restore.
	So, for consistency, on either arrow, select everything, so a new letter-press starts over. yuk."
	searchMorph selectAll.
		
	newindex := self selectedIndex + offset.
	newindex > selectedItems size ifTrue: [ ^ nil ].
	newindex < 1 ifTrue: [ ^ nil ].
	self selectedIndex: newindex.
! !

!DynamicListChooser methodsFor: 'drawing' stamp: 'EP 2/25/2018 14:06'!
moveWindowNear: aPoint
	| trialRect delta |
	trialRect := Rectangle center: aPoint extent: window fullBounds extent.
	delta := trialRect amountToTranslateWithin: World bounds.
	window position: trialRect origin + delta.! !

!DynamicListChooser methodsFor: 'accessing' stamp: 'EP 2/25/2018 14:06'!
realIndex
	^ realIndex ifNil: [ 0 ]! !

!DynamicListChooser methodsFor: 'accessing' stamp: 'EP 2/25/2018 14:06'!
searchText
	^ searchText ifNil: [ searchText := '' ]! !

!DynamicListChooser methodsFor: 'accessing' stamp: 'EP 2/25/2018 14:06'!
searchText: aString
	searchText := aString! !

!DynamicListChooser methodsFor: 'accessing' stamp: 'EP 2/25/2018 14:06'!
selectedIndex
	^ index ifNil: [ index := 1 ]! !

!DynamicListChooser methodsFor: 'accessing' stamp: 'EP 2/25/2018 14:06'!
selectedIndex: anInt
	index := (anInt min: selectedItems size).
	self changed: #selectedIndex.
	self changed: #canAccept.! !

!DynamicListChooser methodsFor: 'accessing' stamp: 'EP 2/25/2018 14:06'!
title
	^ title ifNil: [ title := 'Please choose' ]! !

!DynamicListChooser methodsFor: 'accessing' stamp: 'EP 2/25/2018 14:06'!
title: aString
	title := aString.! !

!DynamicListChooser methodsFor: 'event handling' stamp: 'EP 2/25/2018 14:10'!
updateFilter
	selectedItems := searchText isEmptyOrNil
				ifTrue: [#()]
				ifFalse: [self listBlock value: searchText].
	self changed: #list.
	self selectedIndex: 1.
	self changed: #selectedIndex! !

Object subclass: #PDFCodeInterpreter
	instanceVariableNames: 'commandObjects buffer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-PDF'!

!PDFCodeInterpreter class methodsFor: 'instance creation' stamp: 'EP 2/25/2018 10:40'!
on: aReadStream 
	^ self new on: aReadStream! !

!PDFCodeInterpreter methodsFor: 'accessing' stamp: 'EP 2/28/2018 21:17'!
commandObject: aString 
	^ self commandObjects
		at: aString
		ifAbsent: [self unknownCommand: aString]! !

!PDFCodeInterpreter methodsFor: 'accessing' stamp: 'EP 2/25/2018 17:29'!
commandObjects
	^ commandObjects! !

!PDFCodeInterpreter methodsFor: 'initialize-release' stamp: 'EP 3/1/2018 09:55'!
initialize
	super initialize.
	buffer := SimplePDFRenderTarget new.
	commandObjects := Dictionary new! !

!PDFCodeInterpreter methodsFor: 'parsing' stamp: 'EP 3/4/2018 20:40'!
on: aReadStream 
	aReadStream reset.
	self reset.
	self target beginRender.
	[aReadStream maybeReadWhitespace. 
	aReadStream atEnd] whileFalse: [self parseNext: aReadStream].
	self target endRender.
	^ self target! !

!PDFCodeInterpreter methodsFor: 'parsing' stamp: 'EP 2/25/2018 17:51'!
parseArguments: aReadStream 
	| aList |
	aList := SimpleLinkedList new.
	"self halt: (aReadStream peek: 10)."
	PDFParser new parseAllObjectContent: aReadStream into: aList.
	^ aList asArray! !

!PDFCodeInterpreter methodsFor: 'parsing' stamp: 'EPE 3/16/2018 22:23'!
parseCommand: aReadStream 
	| cmd |
	aReadStream maybeReadWhitespace.
	cmd := aReadStream upToAnyOf: (Character whitespace, (Array with: $[ with: $] with: $/)).
	aReadStream back.
	((cmd anySatisfy: [:c | c isWhitespace])
			or: [(cmd size > 10) or: [cmd size = 0]])
		ifTrue: [self error: 'Argument-parser failed: ' , cmd].
	"Transcript showln: cmd."
	^ self commandObject: cmd! !

!PDFCodeInterpreter methodsFor: 'parsing' stamp: 'EP 2/25/2018 19:53'!
parseNext: aReadStream 
	| args command |
	args := self parseArguments: aReadStream.
	command := self parseCommand: aReadStream.
	command runWithArgs: args! !

!PDFCodeInterpreter methodsFor: 'parsing' stamp: 'EP 3/1/2018 09:55'!
reset
	PDFTextTargetCommand subclasses
		do: [:c | commandObjects
				at: c commandName
				put: (c new target: buffer)].
	^ self! !

!PDFCodeInterpreter methodsFor: 'accessing' stamp: 'EP 2/28/2018 21:57'!
synthesizeCommandClass: aCommandString
	| class inst name |
	name := ('PDF', aCommandString, 'CommandObject') asSymbol.
	(UIManager default confirm: 'Creating PDFTextTargetCommand subclass ', name, ' . OK?') ifFalse: [^ DummyCommandObject new commandName: aCommandString].
	PDFTextTargetCommand subclass: name
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: self class category asString.
	class := Smalltalk at: name.
	class theMetaClass synthesizeGetterFor: 'commandName' value: aCommandString surroundedBySingleQuotes.
	class compile: 'runWithArgs: aCollection', Character cr asString, '  self target unknownCommand: self class commandName' classified: #evaluating notifying: nil.
	inst := class new target: self target.
	self commandObjects at: aCommandString put: inst.
	^ inst! !

!PDFCodeInterpreter methodsFor: 'accessing' stamp: 'EP 2/25/2018 20:19'!
target
	^ buffer! !

!PDFCodeInterpreter methodsFor: 'accessing' stamp: 'EP 2/28/2018 14:17'!
target: aTarget
	buffer := aTarget! !

!PDFCodeInterpreter methodsFor: 'accessing' stamp: 'EP 3/1/2018 09:36'!
unknownCommand: aString 
	| msg |
	msg := aString, ' is an unknown command. Would you like to create a class for it?'.
	(UIManager default confirm: msg)
		ifTrue: [^ self synthesizeCommandClass: aString]
		ifFalse:[self halt. ^ DummyCommandObject new commandName: aString ]! !

Object subclass: #PDFCrossReferenceIndex
	instanceVariableNames: 'refs trailer next'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-PDF'!

!PDFCrossReferenceIndex class methodsFor: 'instance creation' stamp: 'EP 2/23/2018 08:53'!
references: aCollection trailer: aDictionary 
	^ self new references: aCollection asArray; trailer: aDictionary! !

!PDFCrossReferenceIndex methodsFor: 'accessing' stamp: 'EP 2/23/2018 09:36'!
ids
	^ self references collect: [:r | r id]! !

!PDFCrossReferenceIndex methodsFor: 'accessing' stamp: 'EP 2/23/2018 09:12'!
next
	next = 0
		ifTrue: [^ nil].
	^ next! !

!PDFCrossReferenceIndex methodsFor: 'accessing' stamp: 'EP 2/23/2018 09:11'!
next: anInteger 
	"anInteger = 0
		ifTrue: [self error: 'Invalid offset']."
	next := anInteger! !

!PDFCrossReferenceIndex methodsFor: 'accessing' stamp: 'EP 2/23/2018 09:36'!
offsets
	^ self references collect: [:r | r offset]! !

!PDFCrossReferenceIndex methodsFor: 'printing' stamp: 'EP 2/23/2018 09:08'!
printOn: aStream
	aStream nextPutAll: 'PDFCrossReferenceIndex with '; nextPutAll: self references size asString; nextPutAll: ' references and next: '; nextPutAll: self next asString! !

!PDFCrossReferenceIndex methodsFor: 'accessing' stamp: 'EP 2/23/2018 09:42'!
refWithId: anInteger ifAbsent: aBlock 
	^ self references
		detect: [:r | r id = anInteger]
		ifNone: aBlock! !

!PDFCrossReferenceIndex methodsFor: 'accessing' stamp: 'EP 2/23/2018 09:09'!
references
	^ refs! !

!PDFCrossReferenceIndex methodsFor: 'accessing' stamp: 'EP 2/23/2018 08:53'!
references: aCollection 
	refs := aCollection! !

!PDFCrossReferenceIndex methodsFor: 'accessing' stamp: 'EP 2/23/2018 09:29'!
trailer
	^ trailer! !

!PDFCrossReferenceIndex methodsFor: 'accessing' stamp: 'EP 2/23/2018 08:53'!
trailer: aDictionary 
	trailer := aDictionary! !

Object subclass: #PDFGlyphs
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-PDF'!

!PDFGlyphs class methodsFor: 'accessing' stamp: 'EP 3/9/2018 22:41'!
a27
  ^ '<a27>'! !

!PDFGlyphs class methodsFor: 'accessing' stamp: 'EP 3/9/2018 22:38'!
a45
  ^ '<a45>'! !

!PDFGlyphs class methodsFor: 'accessing' stamp: 'EP 3/9/2018 22:38'!
a63
  ^ '<a63>'! !

!PDFGlyphs class methodsFor: 'accessing' stamp: 'EP 3/9/2018 22:42'!
acute
  ^ '<acute>'! !

!PDFGlyphs class methodsFor: 'accessing' stamp: 'EP 3/8/2018 22:13'!
arrowright
  ^ '<arrowright>'! !

!PDFGlyphs class methodsFor: 'accessing' stamp: 'EP 3/8/2018 22:12'!
asterisk
  ^ '*'! !

!PDFGlyphs class methodsFor: 'accessing' stamp: 'EP 3/4/2018 20:17'!
at
	^ '@'! !

!PDFGlyphs class methodsFor: 'accessing' stamp: 'EP 3/8/2018 22:36'!
bar
  ^ '<bar>'! !

!PDFGlyphs class methodsFor: 'accessing' stamp: 'EP 3/8/2018 22:13'!
braceleft
  ^ '{'! !

!PDFGlyphs class methodsFor: 'accessing' stamp: 'EP 3/8/2018 22:13'!
braceright
  ^ '}'! !

!PDFGlyphs class methodsFor: 'accessing' stamp: 'EP 3/4/2018 20:35'!
bracketleft
  ^ '['! !

!PDFGlyphs class methodsFor: 'accessing' stamp: 'EP 3/4/2018 20:36'!
bracketright
  ^ ']'! !

!PDFGlyphs class methodsFor: 'accessing' stamp: 'EP 3/8/2018 22:13'!
bullet
  ^ '<bullet>'! !

!PDFGlyphs class methodsFor: 'converting' stamp: 'EP 3/4/2018 20:35'!
characterRepresentation: aString
	"Assume all single-letter glyphs are named after the character they represent"
	| r |
	aString ifNil: [self error: 'Nil glyph name is an error'].
	(aString size = 1) ifTrue: [^ aString].
	r := self perform: aString asSymbol.
	r isString ifFalse: [self error: r].
	^ r! !

!PDFGlyphs class methodsFor: 'accessing' stamp: 'EP 3/8/2018 22:10'!
colon
  ^ ':'! !

!PDFGlyphs class methodsFor: 'accessing' stamp: 'EP 3/4/2018 20:22'!
comma
	^ ','! !

!PDFGlyphs class methodsFor: 'converting' stamp: 'EP 3/4/2018 20:29'!
doesNotUnderstand: aMessage
	| question |
	question := 'Fill in a placeholder for this glyph name? ', aMessage asString surroundedBySingleQuotes.
	(UIManager default request: question initialAnswer: '<', aMessage asString, '>')
		ifNotNil:
	[:x | self class synthesizeGetterFor: aMessage asString  value: x surroundedBySingleQuotes]
		ifNil: 
	[super doesNotUnderstand: aMessage.]! !

!PDFGlyphs class methodsFor: 'accessing' stamp: 'EP 3/8/2018 22:12'!
dollar
  ^ '$'! !

!PDFGlyphs class methodsFor: 'accessing' stamp: 'EP 3/4/2018 20:30'!
eight
  ^ '8'! !

!PDFGlyphs class methodsFor: 'accessing' stamp: 'EP 3/4/2018 20:37'!
emdash
  ^ '-'! !

!PDFGlyphs class methodsFor: 'accessing' stamp: 'EP 3/8/2018 22:12'!
endash
  ^ '<endash>'! !

!PDFGlyphs class methodsFor: 'accessing' stamp: 'EP 3/8/2018 22:12'!
equal
  ^ '='! !

!PDFGlyphs class methodsFor: 'accessing' stamp: 'EP 3/9/2018 22:41'!
exclam
  ^ '!!'! !

!PDFGlyphs class methodsFor: 'accessing' stamp: 'EP 3/8/2018 22:36'!
existential
  ^ '<existential>'! !

!PDFGlyphs class methodsFor: 'accessing' stamp: 'EP 3/4/2018 20:31'!
ff
  ^ 'ff'! !

!PDFGlyphs class methodsFor: 'accessing' stamp: 'EP 3/4/2018 20:35'!
ffi
  ^ 'ffi'! !

!PDFGlyphs class methodsFor: 'accessing' stamp: 'EP 3/4/2018 20:30'!
fi
  ^ 'fi'! !

!PDFGlyphs class methodsFor: 'accessing' stamp: 'EP 3/8/2018 22:10'!
five
  ^ '5'! !

!PDFGlyphs class methodsFor: 'accessing' stamp: 'EP 3/4/2018 20:31'!
fl
  ^ 'fl'! !

!PDFGlyphs class methodsFor: 'accessing' stamp: 'EP 3/8/2018 22:08'!
four
  ^ '4'! !

!PDFGlyphs class methodsFor: 'accessing' stamp: 'EP 3/9/2018 22:42'!
greater
  ^ '>'! !

!PDFGlyphs class methodsFor: 'accessing' stamp: 'EP 3/4/2018 20:27'!
hyphen
	^ '-'! !

!PDFGlyphs class methodsFor: 'accessing' stamp: 'EP 3/9/2018 22:42'!
less
  ^ '<'! !

!PDFGlyphs class methodsFor: 'accessing' stamp: 'EP 3/8/2018 22:36'!
logicalnot
  ^ '<logicalnot>'! !

!PDFGlyphs class methodsFor: 'accessing' stamp: 'EP 3/4/2018 20:30'!
nine
  ^ '9'! !

!PDFGlyphs class methodsFor: 'accessing' stamp: 'EP 3/4/2018 20:30'!
one
  ^ '1'! !

!PDFGlyphs class methodsFor: 'accessing' stamp: 'EP 3/4/2018 20:31'!
parenleft
  ^ '('! !

!PDFGlyphs class methodsFor: 'accessing' stamp: 'EP 3/4/2018 20:31'!
parenright
  ^ ')'! !

!PDFGlyphs class methodsFor: 'accessing' stamp: 'EP 3/4/2018 20:22'!
period
	^ '.'! !

!PDFGlyphs class methodsFor: 'accessing' stamp: 'EP 3/8/2018 22:12'!
plus
  ^ '+'! !

!PDFGlyphs class methodsFor: 'accessing' stamp: 'EP 3/8/2018 22:12'!
question
  ^ '?'! !

!PDFGlyphs class methodsFor: 'accessing' stamp: 'EP 3/4/2018 20:36'!
quotedblleft
  ^ '"'! !

!PDFGlyphs class methodsFor: 'accessing' stamp: 'EP 3/4/2018 20:38'!
quotedblright
  ^ '"'! !

!PDFGlyphs class methodsFor: 'accessing' stamp: 'EP 3/8/2018 22:13'!
quoteleft
  ^ '"'! !

!PDFGlyphs class methodsFor: 'accessing' stamp: 'EP 3/4/2018 20:36'!
quoteright
  ^ '"'! !

!PDFGlyphs class methodsFor: 'accessing' stamp: 'EP 3/4/2018 20:31'!
seven
  ^ '7'! !

!PDFGlyphs class methodsFor: 'accessing' stamp: 'EP 3/4/2018 20:22'!
six
	^ '6'! !

!PDFGlyphs class methodsFor: 'accessing' stamp: 'EP 3/8/2018 22:12'!
slash
  ^ '/'! !

!PDFGlyphs class methodsFor: 'accessing' stamp: 'EP 3/8/2018 22:07'!
three
  ^ '3'! !

!PDFGlyphs class methodsFor: 'accessing' stamp: 'EP 3/4/2018 20:22'!
two
	^ '2'! !

!PDFGlyphs class methodsFor: 'accessing' stamp: 'EP 3/9/2018 22:41'!
underscore
  ^ '_'! !

!PDFGlyphs class methodsFor: 'accessing' stamp: 'EP 3/4/2018 20:23'!
zero
	^ '0'! !

Object subclass: #PDFLinkedCrossReferenceIndex
	instanceVariableNames: 'xrefs stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-PDF'!

!PDFLinkedCrossReferenceIndex commentStamp: 'EP 2/23/2018 09:15' prior: 0!
I am a linked list of xref-sections that you can use to locate stuff!

!PDFLinkedCrossReferenceIndex class methodsFor: 'instance creation' stamp: 'EP 2/23/2018 09:20'!
xrefs: aCollection stream: aStream 
	^ self new xrefs: aCollection; stream: aStream! !

!PDFLinkedCrossReferenceIndex methodsFor: 'accessing' stamp: 'EP 2/23/2018 09:41'!
ids
	^ self xrefs collect: [:x | x ids]! !

!PDFLinkedCrossReferenceIndex methodsFor: 'accessing' stamp: 'EP 2/23/2018 09:24'!
info
	| id |
	id := self valueOfKey: 'Info'.
	^ self objectWithId: id! !

!PDFLinkedCrossReferenceIndex methodsFor: 'accessing' stamp: 'EP 2/24/2018 14:26'!
objectWithId: aString 
	| offset |
	offset := (self refWithId: aString) offset.
	self stream position: offset.
	^ (PDFParser new xref: self) parseEntity: self stream! !

!PDFLinkedCrossReferenceIndex methodsFor: 'accessing' stamp: 'EP 3/2/2018 16:54'!
objectWithId: aString as: aClass 
	| offset |
	offset := (self refWithId: aString) offset.
	self stream position: offset.
	^ (PDFParser new xref: self) parseObjectDefinition: self stream as: aClass! !

!PDFLinkedCrossReferenceIndex methodsFor: 'accessing' stamp: 'EP 2/23/2018 09:41'!
offsets
	^ self xrefs
		collect: [:x | x offsets]! !

!PDFLinkedCrossReferenceIndex methodsFor: 'accessing' stamp: 'EP 3/7/2018 22:02'!
pages
	^ self root pagesObject pages! !

!PDFLinkedCrossReferenceIndex methodsFor: 'printing' stamp: 'EP 2/23/2018 09:16'!
printOn: aStream 
	aStream nextPutAll: 'PDFLinkedCrossReferenceIndex with ';
		 nextPutAll: self xrefs size asString;
		 nextPutAll: ' xrefs and stream: ';
		 nextPutAll: self stream name! !

!PDFLinkedCrossReferenceIndex methodsFor: 'accessing' stamp: 'EP 2/23/2018 09:43'!
refWithId: anInteger 
	a := self xrefs
		collect: [:x | (x refWithId: anInteger ifAbsent: nil)].
	^ a
		detect: [:x | x isNil not]! !

!PDFLinkedCrossReferenceIndex methodsFor: 'accessing' stamp: 'EP 2/23/2018 20:30'!
root
	| id |
	id := self valueOfKey: 'Root'.
	^ self objectWithId: id! !

!PDFLinkedCrossReferenceIndex methodsFor: 'accessing' stamp: 'EP 2/23/2018 09:17'!
stream

	^ stream! !

!PDFLinkedCrossReferenceIndex methodsFor: 'accessing' stamp: 'EP 2/23/2018 09:17'!
stream: anObject

	stream := anObject! !

!PDFLinkedCrossReferenceIndex methodsFor: 'accessing' stamp: 'EP 2/23/2018 09:24'!
valueOfKey: aString 
	^ (self xrefWithKey: aString) trailer at: aString! !

!PDFLinkedCrossReferenceIndex methodsFor: 'accessing' stamp: 'EP 2/23/2018 09:23'!
xrefWithKey: aString
	| |
	^ self xrefs
				detect: [:x | (x trailer at: aString ifAbsent: nil) isNil not].
	! !

!PDFLinkedCrossReferenceIndex methodsFor: 'accessing' stamp: 'EP 2/23/2018 09:17'!
xrefs

	^ xrefs! !

!PDFLinkedCrossReferenceIndex methodsFor: 'accessing' stamp: 'EP 2/23/2018 09:17'!
xrefs: anObject

	xrefs := anObject! !

Object subclass: #PDFObject
	instanceVariableNames: 'contents xref'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-PDF'!

PDFObject subclass: #PDFCatalogObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-PDF'!

!PDFCatalogObject methodsFor: 'accessing' stamp: 'EP 2/24/2018 15:51'!
metadata
	^ self objectWithId: (self meta at: 'Metadata')! !

!PDFCatalogObject methodsFor: 'accessing' stamp: 'EP 2/28/2018 13:26'!
names

  ^ self xref objectWithId: ( self meta at: 'Names' )! !

!PDFCatalogObject methodsFor: 'accessing' stamp: 'EP 2/28/2018 13:26'!
outlines

  ^ self xref objectWithId: ( self meta at: 'Outlines' )! !

!PDFCatalogObject methodsFor: 'accessing' stamp: 'EP 2/24/2018 15:54'!
pageLabels
	^ self objectWithId: (self meta at: 'PageLabels')! !

!PDFCatalogObject methodsFor: 'accessing' stamp: 'EP 2/28/2018 13:29'!
pagemode

  ^ self meta at: 'PageMode'! !

!PDFCatalogObject methodsFor: 'accessing' stamp: 'EP 3/7/2018 21:49'!
pages
	^ self pagesObject pages! !

!PDFCatalogObject methodsFor: 'accessing' stamp: 'EP 3/7/2018 21:54'!
pagesObject

  ^ self xref objectWithId: ( self meta at: 'Pages' )! !

PDFObject subclass: #PDFEncodingObject
	instanceVariableNames: 'translationTable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-PDF'!

!PDFEncodingObject methodsFor: 'accessing' stamp: 'EP 3/4/2018 16:03'!
differences

  ^ self meta at: 'Differences'! !

!PDFEncodingObject methodsFor: 'initialize-release' stamp: 'EP 3/4/2018 19:43'!
initializeTranslationTable
	| code |
	self translationTable: (Array new: 256).
	code := 0.
	self differences do: [:c | c isNumber 
		ifTrue: [code := c]
		ifFalse: [self translationTable at: (code + 1) put: c. code := code + 1] ]! !

!PDFEncodingObject methodsFor: 'converting' stamp: 'EP 3/4/2018 20:13'!
resolveCharacter: aCharacter
	"Resolves a character to a glyph name"
	aCharacter isCharacter ifFalse: [self halt: aCharacter].
	^ self translationTable at: (aCharacter asInteger + 1)! !

!PDFEncodingObject methodsFor: 'accessing' stamp: 'EP 3/4/2018 19:42'!
translationTable
	translationTable ifNil: [self initializeTranslationTable].
	^ translationTable! !

!PDFEncodingObject methodsFor: 'accessing' stamp: 'EP 3/4/2018 19:38'!
translationTable: anObject

	translationTable := anObject! !

PDFObject subclass: #PDFFontObject
	instanceVariableNames: 'encoding'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-PDF'!

!PDFFontObject methodsFor: 'accessing' stamp: 'EP 3/4/2018 19:59'!
encoding
	encoding ifNotNil: [^ encoding].
	encoding := self xref objectWithId: ( self meta at: 'Encoding' ) as: PDFEncodingObject.
  ^ encoding! !

!PDFFontObject methodsFor: 'accessing' stamp: 'EP 3/2/2018 17:06'!
firstCharacter

  ^ self meta at: 'FirstChar'! !

!PDFFontObject methodsFor: 'accessing' stamp: 'EP 3/2/2018 17:06'!
firstcharacter

  ^ self meta at: 'FirstCharacter'! !

!PDFFontObject methodsFor: 'accessing' stamp: 'EP 3/2/2018 17:08'!
fontDescriptor

  ^ self xref objectWithId: ( self meta at: 'FontDescriptor' )! !

!PDFFontObject methodsFor: 'accessing' stamp: 'EP 3/2/2018 17:07'!
lastCharacter

  ^ self meta at: 'LastChar'! !

!PDFFontObject methodsFor: 'converting' stamp: 'EP 3/4/2018 20:13'!
resolveCharacter: aCharacter 
	| glyph |
	glyph := self encoding resolveCharacter: aCharacter.
	(glyph isNil or: [glyph = '.notdef']) ifTrue: ["self halt: aCharacter" ^ aCharacter ].
	^ PDFGlyphs characterRepresentation: glyph! !

!PDFFontObject methodsFor: 'accessing' stamp: 'EP 3/2/2018 17:30'!
subtype

  ^ self meta at: 'Subtype'! !

!PDFFontObject methodsFor: 'accessing' stamp: 'EP 3/2/2018 17:05'!
widthOf: aCharacter 
	| ix |
	ix := aCharacter asciiValue - self firstCharacter + 1.
	^ self widths at: ix! !

!PDFFontObject methodsFor: 'accessing' stamp: 'EP 3/2/2018 17:04'!
widths
	| obj |
	obj := self xref objectWithId: ( self meta at: 'Widths' ).
	 ^ obj contents second! !

!PDFObject class methodsFor: 'instance creation' stamp: 'EP 3/2/2018 16:56'!
from: aCollection 
	"Return an appropriate subclass to represent the content"
	| subclass |
	"TODO fix this hack later"
	(self = PDFObject) ifFalse: [^ self new contents: aCollection asArray ].
	subclass := self subclassFromContents: aCollection asArray.
	^ subclass new contents: aCollection asArray.! !

!PDFObject class methodsFor: 'compiling' stamp: 'EP 3/2/2018 17:13'!
generateContentGetterFor: aString
	| cr msg |
	cr := Character cr asString.
	(UIManager default confirm: 'Will this get an object?') not
		ifTrue:	[msg := aString asLegalSelector, cr, cr, '  ^ self meta at: ', aString capitalized surroundedBySingleQuotes.]
		ifFalse: [msg := aString asLegalSelector, cr, cr, '  ^ self xref objectWithId: ( self meta at: ', aString capitalized surroundedBySingleQuotes ,' )'].
	msg := UIManager default request: 'Will compile this method into ', self name, '. Ok?' initialAnswer: msg.
	msg isEmpty ifFalse: [self compile: msg classified: #accessing notifying: nil]! !

!PDFObject class methodsFor: 'instance creation' stamp: 'EP 2/24/2018 15:45'!
subclassFromContents: aCollection 
	| meta |
	meta := aCollection second.
	(meta isKindOf: Dictionary)
		ifTrue: [^ self
				subclassFromType: (meta at: 'Type' ifAbsent: PDFObject)].
	^ PDFObject! !

!PDFObject class methodsFor: 'accessing class hierarchy' stamp: 'EP 2/24/2018 15:50'!
subclassFromType: aString 
	aString = 'Pages'
		ifTrue: [^ PDFPagesObject].
	aString = 'Page'
		ifTrue: [^ PDFPageObject].
	aString = 'Catalog'
		ifTrue: [^ PDFCatalogObject].
	^ PDFObject! !

!PDFObject methodsFor: 'accessing' stamp: 'EP 2/28/2018 14:21'!
content
	^ contents! !

!PDFObject methodsFor: 'accessing' stamp: 'EP 2/28/2018 14:21'!
contentStream
	^ self objectContent readStream! !

!PDFObject methodsFor: 'accessing' stamp: 'EP 2/23/2018 20:40'!
contents
	^ contents! !

!PDFObject methodsFor: 'accessing' stamp: 'EP 2/23/2018 09:48'!
contents: aCollection 
	contents := aCollection! !

!PDFObject methodsFor: 'accessing' stamp: 'EP 2/28/2018 13:35'!
dests

  ^ self xref objectWithId: ( self meta at: 'Dests' )! !

!PDFObject methodsFor: 'accessing' stamp: 'EP 3/2/2018 17:14'!
doesNotUnderstand: aMessage
	| question |
	question := 'Is this an expected content field? ', aMessage asString surroundedBySingleQuotes.
	(UIManager default confirm: question)
		ifTrue:
	[self class generateContentGetterFor: aMessage asString. self halt: aMessage]
		ifFalse: 
	[super doesNotUnderstand: aMessage.]! !

!PDFObject methodsFor: 'accessing' stamp: 'EP 3/2/2018 17:13'!
fontFile

  ^ self xref objectWithId: ( self meta at: 'FontFile' )! !

!PDFObject methodsFor: 'accessing' stamp: 'EP 2/24/2018 13:25'!
meta
	(self contents second isKindOf: Dictionary)
		ifFalse: [self error].
	^ self contents second! !

!PDFObject methodsFor: 'accessing' stamp: 'EP 2/28/2018 14:21'!
objectContent
	^ self content third! !

!PDFObject methodsFor: 'object lookup' stamp: 'EP 2/24/2018 15:40'!
objectWithId: anInteger 
	^ self xref objectWithId: anInteger! !

!PDFObject methodsFor: 'object lookup' stamp: 'EP 3/2/2018 16:49'!
objectWithId: anInteger as:aClass
	^ self xref objectWithId: anInteger as: aClass! !

!PDFObject methodsFor: 'accessing' stamp: 'EP 2/28/2018 14:05'!
parent

  ^ self xref objectWithId: ( self meta at: 'Parent' )! !

!PDFObject methodsFor: 'accessing' stamp: 'EP 2/24/2018 14:27'!
printOn: aStream 
	aStream nextPutAll: 'a', self class name asString,' contents: ';
		 nextPutAll: self contents asString! !

!PDFObject methodsFor: 'accessing' stamp: 'EP 2/28/2018 13:30'!
type

  ^ self meta at: 'Type'! !

!PDFObject methodsFor: 'accessing' stamp: 'EP 2/24/2018 14:22'!
xref
	xref
		ifNil: [self error: 'xref not assigned yet'].
	^ xref! !

!PDFObject methodsFor: 'accessing' stamp: 'EP 2/24/2018 14:21'!
xref: anObject

	xref := anObject! !

PDFObject subclass: #PDFPageObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-PDF'!

!PDFPageObject methodsFor: 'accessing' stamp: 'EP 3/4/2018 19:56'!
fonts

  ^ self resources fonts! !

!PDFPageObject methodsFor: 'accessing' stamp: 'EP 3/2/2018 21:39'!
mediaBox
	| coords |
	coords := self meta at: 'MediaBox'.
  ^ Rectangle encompassing: (Array with: (coords first @ coords second) with: (coords third @ coords fourth))! !

!PDFPageObject methodsFor: 'accessing' stamp: 'EP 2/24/2018 15:48'!
pageContentIndex
	^ self meta at: 'Contents'! !

!PDFPageObject methodsFor: 'accessing' stamp: 'EP 2/24/2018 15:48'!
pageContents
	^ self objectWithId: self pageContentIndex! !

!PDFPageObject methodsFor: 'accessing' stamp: 'EP 2/24/2018 15:31'!
pageObjectsInto: aCollection
	aCollection add: self! !

!PDFPageObject methodsFor: 'rendering' stamp: 'EP 3/4/2018 19:55'!
render
	| target |
	target := SimplePDFRenderTarget new.
	target page: self.
	self renderOn: target.
	^ target! !

!PDFPageObject methodsFor: 'rendering' stamp: 'EP 2/28/2018 14:14'!
renderOn: aRenderTarget
	PDFCodeInterpreter new 
		target: aRenderTarget; 
		on: self pageContents contentStream.! !

!PDFPageObject methodsFor: 'accessing' stamp: 'EP 3/2/2018 16:48'!
resources
	^ self objectWithId: self resourcesId as: PDFResouceObject! !

!PDFPageObject methodsFor: 'accessing' stamp: 'EP 2/24/2018 15:35'!
resourcesId
	^ self meta at: 'Resources'! !

PDFObject subclass: #PDFPagesObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-PDF'!

!PDFPagesObject methodsFor: 'accessing' stamp: 'EP 2/24/2018 13:38'!
count
	^ self meta at: 'Count'! !

!PDFPagesObject methodsFor: 'accessing' stamp: 'EP 2/24/2018 13:38'!
kids
	^ self meta at: 'Kids'! !

!PDFPagesObject methodsFor: 'accessing' stamp: 'EP 2/24/2018 13:38'!
meta
	^ self contents second! !

!PDFPagesObject methodsFor: 'accessing' stamp: 'EP 3/3/2018 11:21'!
pageObjects
	| b |
	b := OrderedCollection new.
	self pageObjectsInto: b.
	^ b asArray
! !

!PDFPagesObject methodsFor: 'accessing' stamp: 'EP 2/24/2018 15:33'!
pageObjectsInto: aCollection 
	self kids
		collect: [:x | (self xref objectWithId: x)
				pageObjectsInto: aCollection]! !

!PDFPagesObject methodsFor: 'accessing' stamp: 'EP 3/7/2018 21:55'!
pages
	^ self pageObjects! !

!PDFPagesObject methodsFor: 'accessing' stamp: 'EP 2/24/2018 13:38'!
type
	^ 'Pages'! !

PDFObject subclass: #PDFResouceObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-PDF'!

!PDFResouceObject methodsFor: 'accessing' stamp: 'EP 3/2/2018 16:59'!
fonts

  ^ (self meta at: 'Font') collect: [:x | self objectWithId: x as: PDFFontObject ]! !

!PDFResouceObject methodsFor: 'accessing' stamp: 'EP 3/2/2018 21:43'!
procSet

  ^ self meta at: 'ProcSet'! !

Object subclass: #PDFObjectContentParser
	instanceVariableNames: 'object xref stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-PDF'!

PDFObjectContentParser subclass: #PDFBooleanParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-PDF'!

!PDFBooleanParser methodsFor: 'parsing' stamp: 'EP 2/22/2018 21:04'!
parseObject: aStream
	(aStream peekForString: 'true')
		ifTrue: [aStream readString: 'true'. ^ true].
	(aStream peekForString: 'false')
		ifTrue: [aStream readString: 'false'. ^ false].
	self error: 'Expected either true or false'! !

!PDFBooleanParser methodsFor: 'parsing' stamp: 'EP 2/22/2018 20:56'!
peekParse: aStream 
	^ (aStream peekForString: 'true') or: [aStream peekForString: 'false']! !

PDFObjectContentParser subclass: #PDFDictionaryParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-PDF'!

!PDFDictionaryParser methodsFor: 'parsing' stamp: 'EP 2/21/2018 22:37'!
parseObject: aStream 
	| d |
	d := aStream readPdfDictionary.
	^ d! !

!PDFDictionaryParser methodsFor: 'parsing' stamp: 'EP 2/22/2018 20:25'!
peekParse: aStream 
	^ (aStream peek: 2) = '<<'! !

PDFObjectContentParser subclass: #PDFHexStringParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-PDF'!

!PDFHexStringParser methodsFor: 'parsing' stamp: 'EP 2/22/2018 21:13'!
parseObject: aStream 
	| s p |
	p := aStream position.
	aStream readString: '<'.
	s := aStream upTo: $>.
	s detect: [:c | c isLetter not]
	ifNone: [^ s].
	self error: ('Weird string: ', s, ' at ', p asString).
	^ nil! !

!PDFHexStringParser methodsFor: 'parsing' stamp: 'EP 2/22/2018 21:13'!
peekParse: aStream 
	^ aStream peek = $<
		and: [(aStream peekForString: '<<') not]! !

PDFObjectContentParser subclass: #PDFListParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-PDF'!

!PDFListParser methodsFor: 'parsing' stamp: 'EP 2/24/2018 13:17'!
parseObject: aStream 
	| aLinkedList p |
	aLinkedList := SimpleLinkedList new.
	aStream readString: '['.
		aStream peek = $<
			ifTrue: [^ self parseSpecialStringList: aStream].
	p := PDFParser new parseAllObjectContent: aStream into: aLinkedList.
	aStream readString: ']'.
	^ aLinkedList asArray! !

!PDFListParser methodsFor: 'parsing' stamp: 'EPE 3/16/2018 22:10'!
parseSpecialStringList: aMultiByteFileStream
	| a b |
	aMultiByteFileStream readString: '<'.
	a := aMultiByteFileStream upTo: $>.
	aMultiByteFileStream readString: ' <'.
	b := aMultiByteFileStream upTo: $>.
	(aMultiByteFileStream next = $]) ifFalse: [ self halt ].
	^ Array with: a with: b! !

!PDFListParser methodsFor: 'parsing' stamp: 'EP 2/21/2018 22:42'!
peekParse: aStream 
	^ aStream peek = $[! !

PDFObjectContentParser subclass: #PDFNameObjectParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-PDF'!

!PDFNameObjectParser methodsFor: 'parsing' stamp: 'EP 3/4/2018 15:51'!
parseObject: aStream 
	| n |
	aStream readString: '/'.
	n := aStream upToAnyOf: (Character whitespace, (Array with: $] with: $[ with: $/)).
	aStream back.
	"aStream peek isWhitespace ifFalse: [aStream next]."
	^ n! !

!PDFNameObjectParser methodsFor: 'parsing' stamp: 'EP 2/22/2018 20:54'!
peekParse: aStream 
	^ aStream peek = $/! !

PDFObjectContentParser subclass: #PDFNumberParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-PDF'!

!PDFNumberParser methodsFor: 'parsing' stamp: 'EPE 3/14/2018 22:37'!
parseNumberWithLeadingDot: aReadStream
	| dot digits |
	dot := aReadStream next.
	(aReadStream atEnd or: [aReadStream peek isDigit not])
		 ifTrue: [self error: 'Malformed number'].
	digits := aReadStream upToAnySatisfying: [:c | c isDigit not].
	digits isEmpty ifTrue: [self error: 'Malformed number'].
	"self halt: digits."
	^ ('0.', (String newFrom: digits)) readStream readNumber.! !

!PDFNumberParser methodsFor: 'parsing' stamp: 'EP 3/9/2018 22:35'!
parseObject: aStream 
	| d n p r |
	(aStream peek = $.)
		ifTrue: [^ self parseNumberWithLeadingDot: aStream ].
	d := aStream readNumber.
	"now the first number might be followed by a second
	number and a letter, i.e: '1024 0 R'
	
	Remember the position and try peeking further"
	p := aStream position.
	(Character whitespace includes: aStream peek)
		ifFalse: [^ d ].
	aStream readWhitespace.
	(self peekParse: aStream)
		ifTrue: [n := aStream readNumber.
			(aStream atEnd or: [aStream peek isWhitespace not])
				ifTrue: [aStream position: p. ^ d].
			aStream readWhitespace.
			r := aStream next.
			r = $R
				ifTrue: [^ d "TODO" ]
				ifFalse: [ aStream position: p. ^ d ]
			]
		ifFalse: [aStream position: p].
	^ d! !

!PDFNumberParser methodsFor: 'parsing' stamp: 'EP 3/9/2018 22:33'!
peekParse: aStream 
	aStream atEnd ifTrue: [^ false].
	^ (aStream peek isDigit) or: ['-.' includes: aStream peek]! !

!PDFObjectContentParser methodsFor: 'accessing' stamp: 'EP 2/24/2018 12:22'!
object
	object ifNil: [self error: 'PDFObject requested but hasn''t been assigned yet!!'].
	^ object! !

!PDFObjectContentParser methodsFor: 'accessing' stamp: 'EP 2/24/2018 12:08'!
object: anObject

	object := anObject! !

!PDFObjectContentParser methodsFor: 'accessing' stamp: 'EP 2/24/2018 12:28'!
parse
	"Shorthand for running the parser. Parses content into the current object. Returns true if successful"
	| content |
	content := self parseContent.
	content
		ifNotNil: [self object add: content.
			^ true].
	^ false! !

!PDFObjectContentParser methodsFor: 'accessing' stamp: 'EP 2/24/2018 12:39'!
parseContent
	"Subclasses should override this and implement parsing. Return either nil or content"
	^ self parseObject: self  stream! !

!PDFObjectContentParser methodsFor: 'accessing' stamp: 'EP 2/24/2018 12:27'!
parseObject: aStream 
	"Parse object *content* from the indicated stream"
	"TODO: this method should be renamed in the future"
	self subclassResponsibility! !

!PDFObjectContentParser methodsFor: 'accessing' stamp: 'EP 2/24/2018 12:37'!
peekParse
	"Return if this parser thinks it is possible to parse something"
	^ self peekParse: self stream! !

!PDFObjectContentParser methodsFor: 'accessing' stamp: 'EPE 3/16/2018 22:21'!
stream
	"Sanity check:"
	stream ifNil: [self error: 'Stream requested but hasn''t been assigned yet'].
	"xref
		ifNotNil: [xref stream = stream
				ifFalse: [self error: 'Streams mismatch']]."
	^ stream! !

!PDFObjectContentParser methodsFor: 'accessing' stamp: 'EP 2/24/2018 12:36'!
stream: anObject

	stream := anObject! !

!PDFObjectContentParser methodsFor: 'accessing' stamp: 'EP 2/24/2018 12:20'!
xref
	xref
		ifNil: [self error: 'xref requested but hasn''t been asigned yet!!'].
	^ xref! !

!PDFObjectContentParser methodsFor: 'accessing' stamp: 'EP 2/24/2018 12:10'!
xref: anObject

	xref := anObject! !

PDFObjectContentParser subclass: #PDFStreamParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-PDF'!

!PDFStreamParser methodsFor: 'accessing' stamp: 'EP 2/24/2018 13:07'!
appropriateDecoderFor: aString 
	(aString = 'FlateDecode') ifTrue: [^ ZLibReadStream].
	(aString = 'None') ifTrue: [^ ReadStream ].
	self error: 'Unknown filter ', aString! !

!PDFStreamParser methodsFor: 'converting' stamp: 'EP 2/24/2018 13:08'!
contentFromBytes: aCollection 
	"XML, String, Filter?"
	| meta filter |
	meta := self object last.
	filter := meta at: 'Filter' ifAbsent: 'None'.
	^ ((self appropriateDecoderFor: filter)
		on: aCollection) contents asString! !

!PDFStreamParser methodsFor: 'parsing' stamp: 'EP 2/24/2018 13:02'!
parseContent
	| bytes |
	self parseStartOfStream.
	self stream binary.
	bytes := self stream next: self streamLength.
	self stream ascii.
	self parseEndOfStream.
	^ self contentFromBytes: bytes! !

!PDFStreamParser methodsFor: 'parsing' stamp: 'EP 2/28/2018 13:57'!
parseEndOfStream
	(CharacterSet newlines
			includes: self stream peek)
		ifTrue: [self stream next].
	self stream next: 'endstream' size! !

!PDFStreamParser methodsFor: 'parsing' stamp: 'EP 2/24/2018 12:45'!
parseObject: aStream 
	(aStream = self stream) ifFalse: [self error: 'Stream mismatch'].
	^ self parseContent! !

!PDFStreamParser methodsFor: 'parsing' stamp: 'EP 2/24/2018 12:43'!
parseStartOfStream
	self stream readString: 'stream'.
	(self stream peekForString: Character cr asString)
		ifTrue: [self stream next].
	self stream readString: Character lf asString.
	! !

!PDFStreamParser methodsFor: 'parsing' stamp: 'EP 2/21/2018 22:23'!
peekParse: aStream 
	^ aStream peekForString: 'stream'! !

!PDFStreamParser methodsFor: 'accessing' stamp: 'EP 2/24/2018 12:48'!
streamLength
	^ (self object last at: 'Length')
		pdfNumberValueFor: self! !

PDFObjectContentParser subclass: #PDFStringParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-PDF'!

!PDFStringParser methodsFor: 'parsing' stamp: 'EP 3/4/2018 15:22'!
escapedChar: aCharacter 
	(aCharacter = $\) ifTrue: [^ $\].
	self halt: aCharacter! !

!PDFStringParser methodsFor: 'parsing' stamp: 'EP 3/8/2018 22:35'!
parseEscape: aReadStream 
	aReadStream peek isDigit
		ifTrue: [^ (Integer readFrom: (aReadStream next: 3) readStream radix: 8) asCharacter]
		ifFalse: [ ^ self escapedChar: aReadStream next ]! !

!PDFStringParser methodsFor: 'parsing' stamp: 'EPE 3/14/2018 22:36'!
parseObject: aStream 
	"TODO: how to handle strings with parentheses?"
	| s c |
	aStream readString: '('.
	s := WriteStream with: Array new.
	[s nextPutAll: (aStream upToAnyOf: #($( $) $\)).
	aStream back.
	c := aStream next.
	((c = $)) or: [aStream atEnd]) ifTrue: [^ String newFrom: (s contents)].
	(c = $() ifTrue: [s 
		nextPut: $(; 
		nextPutAll: (aStream upTo: $)); 
		nextPut: $)].
	(c = $\) ifTrue: [s nextPut: (self parseEscape: aStream)]
	] repeat.! !

!PDFStringParser methodsFor: 'parsing' stamp: 'EP 2/22/2018 21:13'!
peekParse: aStream 
	^ aStream peek = $(! !

Object subclass: #PDFObjectReference
	instanceVariableNames: 'offset generation id char'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-PDF'!

!PDFObjectReference class methodsFor: 'instance creation' stamp: 'EP 2/23/2018 08:40'!
offset: anInteger generation: anInteger2 for: anInteger3 char: aCharacter
	| inst |
	inst := self new.
	inst generation: anInteger2;
		 id: anInteger3;
		 offset: anInteger;
		char: aCharacter.
	^ inst! !

!PDFObjectReference methodsFor: 'accessing' stamp: 'EP 2/23/2018 08:42'!
char
	^ char! !

!PDFObjectReference methodsFor: 'accessing' stamp: 'EP 2/22/2018 22:14'!
char: aCharacter 
	char := aCharacter! !

!PDFObjectReference methodsFor: 'accessing' stamp: 'EP 2/23/2018 08:42'!
generation
	^ generation! !

!PDFObjectReference methodsFor: 'accessing' stamp: 'EP 2/22/2018 22:11'!
generation: anInteger 
	generation := anInteger
	! !

!PDFObjectReference methodsFor: 'accessing' stamp: 'EP 2/23/2018 08:42'!
id
	^ id! !

!PDFObjectReference methodsFor: 'accessing' stamp: 'EP 2/22/2018 22:12'!
id: anInteger 
	id := anInteger! !

!PDFObjectReference methodsFor: 'accessing' stamp: 'EP 2/23/2018 08:42'!
offset
	^ offset! !

!PDFObjectReference methodsFor: 'accessing' stamp: 'EP 2/22/2018 22:12'!
offset: anInteger 
	offset := anInteger! !

!PDFObjectReference methodsFor: 'printing' stamp: 'EP 2/23/2018 08:44'!
printOn: aStream 
	^ aStream nextPutAll: 'PDFObjectReference offset: ';
	nextPutAll: self offset asString; nextPutAll: ' generation: '; nextPutAll: self generation asString; nextPutAll: ' for: ' ; nextPutAll: self id asString; nextPutAll: ' char: '; nextPutAll: self char asString! !

Object subclass: #PDFParser
	instanceVariableNames: 'header'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-PDF'!

!PDFParser class methodsFor: 'parsing' stamp: 'EP 2/24/2018 12:13'!
objectContentParsers
	^ PDFObjectContentParser subclasses collect: [:c | c new]! !

!PDFParser class methodsFor: 'parsing' stamp: 'ErikPeldan 2/15/2018 20:27'!
on: aBinaryFileStream
	| instance |
	instance := self new.
	instance on: aBinaryFileStream.
	^ instance! !

!PDFParser class methodsFor: 'parsing' stamp: 'EP 2/24/2018 13:12'!
parseContent: aStream 
	"For quickly parsing some PDF (object) content"
	| parser parsers |
	parsers := self objectContentParsers.
	parsers
		do: [:p | p stream: aStream].
	parser :=  parsers
				detect: [:p | p peekParse]
				ifNone: [^ nil].
	^ parser parseContent! !

!PDFParser class methodsFor: 'instance creation' stamp: 'EP 2/24/2018 12:18'!
xref: xref
	"Return a PDFParser with the assigned xref"
	^ self new xref: xref! !

!PDFParser methodsFor: 'accessing' stamp: 'EP 2/28/2018 14:29'!
appropriateParser
	"Find a suitable parser for next content"
	^ self parsers
				detect: [:p | p peekParse]
				ifNone: [^ nil].
	! !

!PDFParser methodsFor: 'parsing' stamp: 'EP 2/23/2018 08:35'!
extractXref: aStream 
	self locateXref: aStream.
	^ self parseXref: aStream! !

!PDFParser methodsFor: 'parsing' stamp: 'EP 3/2/2018 16:58'!
extractXrefs: aStream 
	"Parse out the linked cross section object from the PDF, from which you can read the rest of it"
	| list x ps |
	ps := OrderedCollection new.
	list := SimpleLinkedList new.
	
	self locateXref: aStream.
	
	ps add: aStream position.
	x := self parseXref: aStream.
	list add: x.
	[(x next isNil
		or: [x next = 0]) or: [ps includes: x next]]
		whileFalse: [
			ps add: x next.
			aStream position: x next.
			x := self parseXref: aStream.
			list add: x].
	^ PDFLinkedCrossReferenceIndex xrefs: (list asArray) stream: aStream! !

!PDFParser methodsFor: 'accessing' stamp: 'ErikPeldan 2/15/2018 20:22'!
header
	^ header! !

!PDFParser methodsFor: 'accessing' stamp: 'ErikPeldan 2/15/2018 20:22'!
header: anObject
	header := anObject! !

!PDFParser methodsFor: 'initialize-release' stamp: 'EP 2/24/2018 12:12'!
initialize
	self parsers: self class objectContentParsers! !

!PDFParser methodsFor: 'parsing' stamp: 'EP 2/23/2018 08:37'!
locateXref: aStream 
	aStream setToEnd.
	aStream backUpTo: 'startxref'; goBack: 'startxref' size.
	
	aStream backUpTo: 'xref';
	goBack: 'xref' size! !

!PDFParser methodsFor: 'parsing' stamp: 'ErikPeldan 2/16/2018 17:22'!
on: aStream
	"Read the binary magic value header"
	aStream binary; reset.
	self parseHeader: aStream.
	self parseObject: aStream.
	self parseXref: aStream.
	^ self! !

!PDFParser methodsFor: 'parsing' stamp: 'EP 2/25/2018 17:21'!
parseAllObjectContent: aStream into: anObject 
	aStream ascii.
	"Initialize the parsers"
	self parsers
		do: [:p | p object: anObject;
				 xref: self xref;
				 stream: aStream].
	[aStream maybeReadWhitespace.
	self parseObjectContent] whileTrue.
	^ anObject! !

!PDFParser methodsFor: 'parsing' stamp: 'EP 2/24/2018 12:17'!
parseEntity: aStream 
	"Parse either an xref or object definition"
	aStream atEnd
		ifTrue: [^ nil].
	(aStream peekForString: 'xref')
		ifTrue: [^ self parseXref: aStream]
		ifFalse: [^ self parseObjectDefinition: aStream]! !

!PDFParser methodsFor: 'parsing' stamp: 'ErikPeldan 2/15/2018 21:24'!
parseHeader: aStream
	aStream binary.
	self header: aStream readLine.
	aStream ascii.
	aStream readLine.	"Read the binary magic value header"
	! !

!PDFParser methodsFor: 'parsing' stamp: 'ErikPeldan 2/16/2018 17:22'!
parseObject: aStream
	| n1 n2 d |
	aStream ascii.
	n1 := aStream readNumber.
	aStream readWhitespace.
	n2 := aStream readNumber.
	aStream
		readWhitespace;
		readString: 'obj';
		readWhitespace.
		
	d :=	aStream readPdfDictionary.
	aStream readString: 'endobj'.
	aStream readCrNewline.
	aStream readSpaces.! !

!PDFParser methodsFor: 'parsing' stamp: 'EP 2/25/2018 17:52'!
parseObjectContent
	"Parse a basic object *content* type, e.g boolean,
	number, dictionary etc"
	| p |
	p := self appropriateParser.
"	self halt: (p class asString)."
	p
		ifNil: [^ false].
	^ p parse! !

!PDFParser methodsFor: 'parsing' stamp: 'EP 3/2/2018 16:53'!
parseObjectDefinition: aStream 
	^ self parseObjectDefinition: aStream as: PDFObject! !

!PDFParser methodsFor: 'parsing' stamp: 'EP 3/2/2018 16:52'!
parseObjectDefinition: aStream as:aClass
	"Parses a section containing an object definition. For
	example: 
	1024 0 obj
	(foo)
	endobj
	
	is an object definition"
	| obj |
	aStream ascii.
	obj := self readObjectHeader: aStream.
	self parseAllObjectContent: aStream into: obj.
	aStream readString: 'endobj'.
	aStream readWhitespace.
	^ (aClass from: obj) xref: self xref! !

!PDFParser methodsFor: 'parsing' stamp: 'EP 2/23/2018 09:03'!
parseXref: aStream 
	| n1 n2 refs d next |
	aStream readString: 'xref'.
	n1 := aStream readWhitespace; readNumber.
	n2 := aStream readWhitespace; readNumber.
	aStream readWhitespace.
	refs := SimpleLinkedList new.
	n1
		to: n1 + n2 - 1
		do: [:n | refs
				add: (self readObjectReference: aStream for: n)].
	"[aStream peek isDigit]
	whileTrue: [aStream upTo: Character lf]."
	aStream readString: 'trailer';
		 readWhitespace.
	d := aStream readPdfDictionary.
	aStream readWhitespace.
	aStream readString: 'startxref'.
	aStream readWhitespace.
	next := aStream readNumber.
	aStream readWhitespace.
	aStream readString: '%%EOF'.
	aStream atEnd
		ifFalse: [aStream readWhitespace].
	^ (PDFCrossReferenceIndex references: refs trailer: d) next: next! !

!PDFParser methodsFor: 'accessing' stamp: 'EP 2/24/2018 12:11'!
parsers

	^ parsers! !

!PDFParser methodsFor: 'accessing' stamp: 'EP 2/24/2018 12:11'!
parsers: aCollection 
	parsers := aCollection! !

!PDFParser methodsFor: 'parsing' stamp: 'EP 2/23/2018 21:21'!
readObjectHeader: aStream 
	| n1 n2 obj |
	obj := SimpleLinkedList new.
	n1 := aStream readNumber.
	aStream readWhitespace.
	n2 := aStream readNumber.
	aStream readWhitespace; readString: 'obj'.
	"Transcript showln: 'Header read'."
	obj add: (Array with: n1 with: n2).
	^ obj! !

!PDFParser methodsFor: 'parsing' stamp: 'EP 2/23/2018 08:41'!
readObjectReference: aStream for: anInteger 
	| c n n2 |
	n := IntegerParser parse: aStream.
	aStream readWhitespace.
	n2 := IntegerParser parse: aStream.
	aStream readWhitespace.
	c := aStream next.
	aStream readWhitespace.
	^ PDFObjectReference
		offset: n
		generation: n2
		for: anInteger
		 char: c! !

!PDFParser methodsFor: 'accessing' stamp: 'EP 2/24/2018 12:11'!
xref

	^ xref! !

!PDFParser methodsFor: 'accessing' stamp: 'EP 2/24/2018 12:11'!
xref: anObject

	xref := anObject! !

Object subclass: #PDFTextTargetCommand
	instanceVariableNames: 'target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-PDF'!

!PDFTextTargetCommand commentStamp: 'EP 2/26/2018 22:09' prior: 0!
I am a 'command object' that when executed forwards its output to a target WriteStream!

PDFTextTargetCommand subclass: #DummyCommandObject
	instanceVariableNames: 'commandName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-PDF'!

!DummyCommandObject class methodsFor: 'accessing' stamp: 'EP 2/25/2018 20:26'!
commandName
	^ '?'! !

!DummyCommandObject class methodsFor: 'instance creation' stamp: 'EP 2/25/2018 17:34'!
named: aString 
	^ self new commandName: aString! !

!DummyCommandObject methodsFor: 'accessing' stamp: 'EP 2/25/2018 17:33'!
commandName
	^ commandName! !

!DummyCommandObject methodsFor: 'accessing' stamp: 'EP 2/25/2018 17:34'!
commandName: aString 
	commandName := aString! !

!DummyCommandObject methodsFor: 'evaluating' stamp: 'EP 2/26/2018 22:10'!
runWithArgs: aCollection 
	self target unknownCommand: self commandName! !

PDFTextTargetCommand subclass: #PDFBTCommandObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-PDF'!

!PDFBTCommandObject class methodsFor: 'accessing' stamp: 'EP 2/28/2018 21:58'!
commandName
  ^ 'BT'! !

!PDFBTCommandObject methodsFor: 'evaluating' stamp: 'EP 2/28/2018 22:28'!
runWithArgs: aCollection
  self target beginText! !

PDFTextTargetCommand subclass: #PDFETCommandObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-PDF'!

!PDFETCommandObject class methodsFor: 'accessing' stamp: 'EP 2/28/2018 21:58'!
commandName
  ^ 'ET'! !

!PDFETCommandObject methodsFor: 'evaluating' stamp: 'EP 2/28/2018 22:28'!
runWithArgs: aCollection
  self target endText! !

PDFTextTargetCommand subclass: #PDFGCommandObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-PDF'!

!PDFGCommandObject class methodsFor: 'accessing' stamp: 'EP 2/28/2018 21:57'!
commandName
  ^ 'G'! !

!PDFGCommandObject methodsFor: 'evaluating' stamp: 'EP 2/28/2018 22:23'!
runWithArgs: aCollection
  self target strokingGrayness: aCollection first! !

PDFTextTargetCommand subclass: #PDFJCommandObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-PDF'!

!PDFJCommandObject class methodsFor: 'accessing' stamp: 'EP 3/1/2018 09:39'!
commandName
  ^ 'J'! !

!PDFJCommandObject methodsFor: 'evaluating' stamp: 'EP 3/1/2018 09:39'!
runWithArgs: aCollection
  self target unknownCommand: self class commandName! !

PDFTextTargetCommand subclass: #PDFQCommandObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-PDF'!

!PDFQCommandObject class methodsFor: 'accessing' stamp: 'EP 3/1/2018 09:40'!
commandName
  ^ 'Q'! !

!PDFQCommandObject methodsFor: 'evaluating' stamp: 'EP 3/1/2018 09:40'!
runWithArgs: aCollection
  self target unknownCommand: self class commandName! !

PDFTextTargetCommand subclass: #PDFSCommandObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-PDF'!

!PDFSCommandObject class methodsFor: 'accessing' stamp: 'EP 3/1/2018 09:40'!
commandName
  ^ 'S'! !

!PDFSCommandObject methodsFor: 'evaluating' stamp: 'EP 3/1/2018 09:40'!
runWithArgs: aCollection
  self target unknownCommand: self class commandName! !

PDFTextTargetCommand subclass: #PDFTDCommandObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-PDF'!

!PDFTDCommandObject class methodsFor: 'accessing' stamp: 'EP 2/25/2018 20:27'!
commandName
	^ 'TD'! !

!PDFTDCommandObject methodsFor: 'evaluating' stamp: 'EP 2/26/2018 22:10'!
runWithArgs: aCollection 
	self target tdWithX: aCollection first y: aCollection second.
! !

!PDFTDCommandObject methodsFor: 'evaluating' stamp: 'EP 2/26/2018 22:10'!
runWithArgsOld: aCollection 
	| x y c |
	x := aCollection first.
	y := aCollection second.
	"((y = 0) not
	and: [x <= 0])
	ifTrue: [
	self target nextPutAll: '<NEW SECTION>']."
	"self target nextPutAll: '<NEWLINE ' , x asString , ', ' , y
	asString , '>'.
	"
	y < 0
		ifTrue: [self target nextPutAll: '<NEWLINE' , y asString , '>'].
	c := y = 0
				ifTrue: [Character space]
				ifFalse: [^ Character cr].
	"self halt: aCollection asString."
	self target peekLast isWhitespace
		ifFalse: [self target nextPut: c]! !

PDFTextTargetCommand subclass: #PDFTJCommandObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-PDF'!

!PDFTJCommandObject class methodsFor: 'accessing' stamp: 'EP 2/25/2018 20:26'!
commandName
	^ 'TJ'! !

!PDFTJCommandObject methodsFor: 'evaluating' stamp: 'EP 3/3/2018 11:03'!
runWithArgs: aCollection 
	self target showTextArray: aCollection! !

!PDFTJCommandObject methodsFor: 'evaluating' stamp: 'EP 3/1/2018 22:54'!
runWithArgsOld: aCollection
	Transcript showln: 'TJ + ', aCollection.
	(aCollection first
		select: [:x | x isCollection])
		do: [:x | self target nextPutAll: x]! !

PDFTextTargetCommand subclass: #PDFTcCommandObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-PDF'!

!PDFTcCommandObject class methodsFor: 'accessing' stamp: 'EP 2/25/2018 23:12'!
commandName
	^ 'Tc'! !

!PDFTcCommandObject methodsFor: 'evaluating' stamp: 'EP 2/26/2018 22:14'!
runWithArgs: aCollection 
	self target characterSpacing: aCollection! !

!PDFTcCommandObject methodsFor: 'evaluating' stamp: 'EP 2/26/2018 22:14'!
runWithArgsOld: aCollection 
	| x |
	x := aCollection first! !

PDFTextTargetCommand subclass: #PDFTdCommandObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-PDF'!

!PDFTdCommandObject class methodsFor: 'accessing' stamp: 'EP 2/28/2018 21:58'!
commandName
  ^ 'Td'! !

!PDFTdCommandObject methodsFor: 'evaluating' stamp: 'EP 3/3/2018 11:00'!
runWithArgs: aCollection
  self target textPosition: aCollection first @ aCollection second! !

!PDFTextTargetCommand methodsFor: 'accessing' stamp: 'EP 2/25/2018 20:13'!
target
	^ target! !

!PDFTextTargetCommand methodsFor: 'accessing' stamp: 'EP 2/25/2018 20:13'!
target: anObject 
	target := anObject! !

PDFTextTargetCommand subclass: #PDFTfCommandObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-PDF'!

!PDFTfCommandObject class methodsFor: 'accessing' stamp: 'EP 2/28/2018 21:58'!
commandName
  ^ 'Tf'! !

!PDFTfCommandObject methodsFor: 'evaluating' stamp: 'EP 2/28/2018 22:24'!
runWithArgs: aCollection
  self target fontName: aCollection first size: aCollection second! !

PDFTextTargetCommand subclass: #PDFTjCommandObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-PDF'!

!PDFTjCommandObject class methodsFor: 'accessing' stamp: 'EP 2/25/2018 20:27'!
commandName
	^ 'Tj'! !

!PDFTjCommandObject methodsFor: 'evaluating' stamp: 'EP 2/26/2018 22:14'!
runWithArgs: aCollection 
	self target drawText: aCollection! !

!PDFTjCommandObject methodsFor: 'evaluating' stamp: 'EP 2/26/2018 22:13'!
runWithArgsOld: aCollection 
	self target
		nextPutAll: (aCollection first
				select: [:x | x isCharacter])! !

PDFTextTargetCommand subclass: #PDFTmCommandObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-PDF'!

!PDFTmCommandObject class methodsFor: 'accessing' stamp: 'EP 2/25/2018 20:51'!
commandName
	^ 'Tm'! !

!PDFTmCommandObject methodsFor: 'evaluating' stamp: 'EP 2/26/2018 22:15'!
runWithArgs: aCollection 
	self target textMatrix: aCollection! !

PDFTextTargetCommand subclass: #PDFTwCommandObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-PDF'!

!PDFTwCommandObject class methodsFor: 'accessing' stamp: 'EP 2/25/2018 23:11'!
commandName
	^ 'Tw'! !

!PDFTwCommandObject methodsFor: 'evaluating' stamp: 'EP 2/26/2018 22:15'!
runWithArgs: aCollection 
	self target wordSpacing: aCollection! !

PDFTextTargetCommand subclass: #PDFcmCommandObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-PDF'!

!PDFcmCommandObject class methodsFor: 'accessing' stamp: 'EP 2/28/2018 21:34'!
commandName
  ^ 'cm'! !

!PDFcmCommandObject methodsFor: 'evaluating' stamp: 'EP 3/3/2018 10:55'!
runWithArgs: aCollection 
	self target graphicsMatrix: aCollection
	! !

PDFTextTargetCommand subclass: #PDFdCommandObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-PDF'!

!PDFdCommandObject class methodsFor: 'accessing' stamp: 'EP 3/1/2018 09:39'!
commandName
  ^ 'd'! !

!PDFdCommandObject methodsFor: 'evaluating' stamp: 'EP 3/1/2018 09:39'!
runWithArgs: aCollection
  self target unknownCommand: self class commandName! !

PDFTextTargetCommand subclass: #PDFfCommandObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-PDF'!

!PDFfCommandObject class methodsFor: 'accessing' stamp: 'EP 3/1/2018 09:55'!
commandName
  ^ 'f'! !

!PDFfCommandObject methodsFor: 'evaluating' stamp: 'EP 3/1/2018 09:55'!
runWithArgs: aCollection
  self target unknownCommand: self class commandName! !

PDFTextTargetCommand subclass: #PDFgCommandObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-PDF'!

!PDFgCommandObject class methodsFor: 'accessing' stamp: 'EP 2/28/2018 21:54'!
commandName
  ^ 'g'! !

!PDFgCommandObject methodsFor: 'evaluating' stamp: 'EP 2/28/2018 22:22'!
runWithArgs: aCollection 
	self target grayness: aCollection first! !

PDFTextTargetCommand subclass: #PDFlCommandObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-PDF'!

!PDFlCommandObject class methodsFor: 'accessing' stamp: 'EP 3/1/2018 09:40'!
commandName
  ^ 'l'! !

!PDFlCommandObject methodsFor: 'evaluating' stamp: 'EP 3/1/2018 09:40'!
runWithArgs: aCollection
  self target unknownCommand: self class commandName! !

PDFTextTargetCommand subclass: #PDFmCommandObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-PDF'!

!PDFmCommandObject class methodsFor: 'accessing' stamp: 'EP 3/1/2018 09:40'!
commandName
  ^ 'm'! !

!PDFmCommandObject methodsFor: 'evaluating' stamp: 'EP 3/1/2018 09:40'!
runWithArgs: aCollection
  self target unknownCommand: self class commandName! !

PDFTextTargetCommand subclass: #PDFqCommandObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-PDF'!

!PDFqCommandObject class methodsFor: 'accessing' stamp: 'EP 2/26/2018 22:24'!
commandName
	^ 'q'! !

!PDFqCommandObject methodsFor: 'evaluating' stamp: 'EP 2/26/2018 22:24'!
runWithArgs: aCollection 
	self target pushGraphicsState! !

PDFTextTargetCommand subclass: #PDFreCommandObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-PDF'!

!PDFreCommandObject class methodsFor: 'accessing' stamp: 'EP 3/1/2018 09:55'!
commandName
  ^ 're'! !

!PDFreCommandObject methodsFor: 'evaluating' stamp: 'EP 3/1/2018 09:55'!
runWithArgs: aCollection
  self target unknownCommand: self class commandName! !

PDFTextTargetCommand subclass: #PDFwCommandObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-PDF'!

!PDFwCommandObject class methodsFor: 'accessing' stamp: 'EP 3/1/2018 09:40'!
commandName
  ^ 'w'! !

!PDFwCommandObject methodsFor: 'evaluating' stamp: 'EP 3/1/2018 09:40'!
runWithArgs: aCollection
  self target unknownCommand: self class commandName! !

Object subclass: #SimpleLinkedList
	instanceVariableNames: 'linkedlist'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-Collections'!

!SimpleLinkedList methodsFor: 'adding' stamp: 'EPE 3/14/2018 22:59'!
add: anObject
	self linkedlist add: (anObject)! !

!SimpleLinkedList methodsFor: 'converting' stamp: 'EPE 3/16/2018 21:44'!
asArray
	^ (self linkedlist collect: [:x | x]) asArray! !

!SimpleLinkedList methodsFor: 'adding' stamp: 'EP 2/18/2018 20:15'!
at: anInteger 
	^ (self linkedlist at: anInteger) element! !

!SimpleLinkedList methodsFor: 'accessing' stamp: 'EP 2/18/2018 18:38'!
collect: aBlockClosure 
	^ self linkedlist
		collect: [:aStackLink | aBlockClosure value: aStackLink element]! !

!SimpleLinkedList methodsFor: 'accessing' stamp: 'EP 2/21/2018 22:47'!
elements
	^ (self collect: [:x | x]) asArray! !

!SimpleLinkedList methodsFor: 'accessing' stamp: 'EP 2/22/2018 23:27'!
first
	^ self linkedlist first element! !

!SimpleLinkedList methodsFor: 'adding' stamp: 'EP 2/18/2018 18:32'!
initialize
	self linkedlist: (LinkedList new).
	^ self! !

!SimpleLinkedList methodsFor: 'accessing' stamp: 'EPE 3/16/2018 22:19'!
last
	^ self linkedlist last! !

!SimpleLinkedList methodsFor: 'accessing' stamp: 'EP 2/18/2018 18:33'!
linkedlist

	^ linkedlist! !

!SimpleLinkedList methodsFor: 'accessing' stamp: 'EP 2/18/2018 18:33'!
linkedlist: anObject

	linkedlist := anObject! !

!SimpleLinkedList methodsFor: 'adding' stamp: 'EP 2/25/2018 19:48'!
printOn: aStream
	aStream nextPutAll: 'aSimpleLinkedList ('.
	self linkedlist printOn: aStream.
	aStream nextPutAll: ')'! !

!SimpleLinkedList methodsFor: 'adding' stamp: 'EP 2/18/2018 18:39'!
size
	^ self linkedlist size! !

Object subclass: #SimplePDFRenderTarget
	instanceVariableNames: 'textboxes page postprocessor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-PDF'!

!SimplePDFRenderTarget commentStamp: 'EP 3/7/2018 21:24' prior: 0!
I represent the result of rendering a page.

I keep track of text boxes that get rendered, so that they can later be written to a text stream!

!SimplePDFRenderTarget methodsFor: 'rendering' stamp: 'EP 3/4/2018 20:40'!
beginRender
	! !

!SimplePDFRenderTarget methodsFor: 'rendering' stamp: 'EP 3/3/2018 22:16'!
beginText
	"self halt."
	self beginTextBox! !

!SimplePDFRenderTarget methodsFor: 'rendering' stamp: 'EP 3/3/2018 22:01'!
beginTextBox
	self textboxes add: TextBox new! !

!SimplePDFRenderTarget methodsFor: 'rendering' stamp: 'EP 3/7/2018 21:38'!
endRender
	self postprocess.! !

!SimplePDFRenderTarget methodsFor: 'rendering' stamp: 'EP 3/3/2018 11:11'!
endText
	"self shouldBeImplemented"! !

!SimplePDFRenderTarget methodsFor: 'rendering' stamp: 'EP 3/4/2018 15:30'!
fontName: aString size: aNumber 
	| font |
	font := self lookupFont: aString.
	self textbox hasContent
		ifTrue: [self beginTextBox].
	self textbox font: font size: aNumber.! !

!SimplePDFRenderTarget methodsFor: 'rendering' stamp: 'EP 3/3/2018 10:55'!
graphicsMatrix: aCollection 
	"self shouldBeImplemented"! !

!SimplePDFRenderTarget methodsFor: 'rendering' stamp: 'EP 3/3/2018 10:55'!
grayness: anInteger 
	"self shouldBeImplemented"! !

!SimplePDFRenderTarget methodsFor: 'initialize-release' stamp: 'EP 3/7/2018 21:38'!
initialize
	super initialize.
	textboxes := OrderedCollection new.
	postprocessor := TextBoxesAdjustment new allButLast! !

!SimplePDFRenderTarget methodsFor: 'accessing' stamp: 'EP 3/4/2018 19:54'!
lookupFont: aString 
	^ self page fonts at: aString ! !

!SimplePDFRenderTarget methodsFor: 'accessing' stamp: 'EP 3/4/2018 19:55'!
page
	^ page! !

!SimplePDFRenderTarget methodsFor: 'accessing' stamp: 'EP 3/4/2018 19:56'!
page: aPDFPageObject 
	page := aPDFPageObject! !

!SimplePDFRenderTarget methodsFor: 'rendering' stamp: 'EP 3/7/2018 21:31'!
postprocess
	self postprocessor run: self! !

!SimplePDFRenderTarget methodsFor: 'accessing' stamp: 'EP 3/7/2018 21:31'!
postprocessor
	^ postprocessor! !

!SimplePDFRenderTarget methodsFor: 'rendering' stamp: 'EP 3/3/2018 11:15'!
pushGraphicsState
	"self shouldBeImplemented"! !

!SimplePDFRenderTarget methodsFor: 'rendering' stamp: 'EP 3/3/2018 11:05'!
showTextArray: aCollection 
	self textbox showTextArray: aCollection first! !

!SimplePDFRenderTarget methodsFor: 'rendering' stamp: 'EP 3/3/2018 10:55'!
strokingGrayness: anInteger 
	"self shouldBeImplemented"! !

!SimplePDFRenderTarget methodsFor: 'rendering' stamp: 'EP 3/3/2018 11:00'!
textPosition: aPoint
	self textbox textPosition: aPoint! !

!SimplePDFRenderTarget methodsFor: 'accessing' stamp: 'EP 3/3/2018 10:58'!
textbox
	^ self textboxes last! !

!SimplePDFRenderTarget methodsFor: 'accessing' stamp: 'EP 3/3/2018 10:57'!
textboxes
	^ textboxes! !

!SimplePDFRenderTarget methodsFor: 'accessing' stamp: 'EP 3/4/2018 20:41'!
textboxes: aCollection 
	textboxes := aCollection! !

!SimplePDFRenderTarget methodsFor: 'rendering' stamp: 'EP 3/3/2018 11:15'!
unknownCommand: aString 
	"self shouldBeImplemented"! !

!SimplePDFRenderTarget methodsFor: 'error handling' stamp: 'EP 2/28/2018 22:05'!
unknownCommand: aString args: aCollection 
	Transcript showln: aString, ' <- ', aCollection.! !

Object subclass: #TextBox
	instanceVariableNames: 'writeStream bounds font fontSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-Text'!

!TextBox methodsFor: 'accessing' stamp: 'EP 3/3/2018 11:26'!
contents
	^ self writeStream contents asByteArray asString! !

!TextBox methodsFor: 'accessing' stamp: 'EP 3/4/2018 15:27'!
font
	^ font! !

!TextBox methodsFor: 'accessing' stamp: 'EP 3/3/2018 22:01'!
font: aFont size: aNumber 
	self writeStream isEmpty ifFalse: [self error: 'Cannot change font when already written to. Start a new textbox instead!!'].
	font := aFont.
	fontSize := aNumber! !

!TextBox methodsFor: 'accessing' stamp: 'EP 3/10/2018 12:51'!
fontSize
	^ fontSize! !

!TextBox methodsFor: 'accessing' stamp: 'EP 3/3/2018 22:04'!
hasContent
	^ self writeStream isEmpty not! !

!TextBox methodsFor: 'accessing' stamp: 'EP 3/10/2018 12:51'!
length
	^ self contents size! !

!TextBox methodsFor: 'rendering' stamp: 'EP 3/3/2018 11:12'!
nextPutAll: aString 
	self writeStream nextPutAll: aString! !

!TextBox methodsFor: 'printing' stamp: 'EPE 3/16/2018 22:24'!
printOn: aStream
	aStream nextPutAll: 'aTextBox ("', ((String newFrom: (self writeStream contents)) truncateTo: 300), '")'! !

!TextBox methodsFor: 'accessing' stamp: 'EP 3/10/2018 13:02'!
sample
	^ self contents copyFrom: 1 to: (100 min: self contents size)! !

!TextBox methodsFor: 'rendering' stamp: 'EP 3/4/2018 20:32'!
showText: aString
	| s |
	s := aString readStream.
	[s atEnd] whileFalse: [
		self writeStream nextPutAll: (self font resolveCharacter: s next).
	].
	! !

!TextBox methodsFor: 'rendering' stamp: 'EP 3/3/2018 11:05'!
showTextArray: aCollection 
	aCollection do: [:x | 
		x asPdfShowArgOn: self].! !

!TextBox methodsFor: 'accessing' stamp: 'EP 3/3/2018 11:10'!
spaceWidth
	^ 300 "TODO later, ask the font"! !

!TextBox methodsFor: 'accessing' stamp: 'EP 3/3/2018 22:25'!
textPosition: anOffset
	| aPoint |
	aPoint := anOffset asPdfOffsetPoint. 
	"self halt: anOffset."
	aPoint y isZero
		ifTrue: [self textPositionX: aPoint x]
		ifFalse: [self textPositionY: aPoint y].
	"(aPoint y isZero and: [aPoint x > (self spaceWidth * 0.8)])
		ifTrue: [self nextPutAll: Character space asString].
	(aPoint y isZero not)
		ifTrue: [self nextPutAll: Character space asString]."! !

!TextBox methodsFor: 'rendering' stamp: 'EP 3/3/2018 22:29'!
textPositionX: anInteger
	self hasContent ifFalse: [^ self].
	(anInteger > (self spaceWidth * 0.8))
		ifTrue: [self nextPutAll: Character space asString].
	! !

!TextBox methodsFor: 'rendering' stamp: 'EP 3/3/2018 22:30'!
textPositionY: aNumber 
	self hasContent
		ifFalse: [^ self].
	(self writeStream peekLast = $-)
		ifTrue: [self writeStream skip: -1. ^ self].
	self nextPutAll: Character space asString.! !

!TextBox methodsFor: 'accessing' stamp: 'EP 3/3/2018 11:08'!
writeStream
	writeStream ifNil: [writeStream := WriteStream on: (Array new: 100)].
	^ writeStream! !

Object subclass: #TextBoxStatistics
	instanceVariableNames: 'stats samples'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-PDF'!

!TextBoxStatistics class methodsFor: 'instance creation' stamp: 'EP 3/10/2018 13:01'!
from: aCollection
	| stats |
	stats := TextBoxStatistics new.
	aCollection do: [:textbox | stats count: textbox].
	^ stats! !

!TextBoxStatistics methodsFor: 'accessing' stamp: 'EP 3/10/2018 13:03'!
count: aTextBox 
	| aFontSize aLength prev |
	aFontSize := aTextBox fontSize.
	aLength := aTextBox contents size.
	prev := self stats at: aFontSize 
		ifAbsent: [
			self samples at: aFontSize put: aTextBox sample. 
			0].
	self stats at: aFontSize put: prev + aLength! !

!TextBoxStatistics methodsFor: 'accessing' stamp: 'EP 3/10/2018 13:07'!
initialize
	super initialize.
	stats := Dictionary new.
	samples := Dictionary new.! !

!TextBoxStatistics methodsFor: 'accessing' stamp: 'EP 3/10/2018 13:07'!
samples
	^ samples! !

!TextBoxStatistics methodsFor: 'accessing' stamp: 'EP 3/10/2018 12:58'!
stats
	^ stats! !

!TextBoxStatistics methodsFor: 'accessing' stamp: 'EP 3/10/2018 13:03'!
storeSample: aString 
	self shouldBeImplemented! !

Object subclass: #TextBoxesAdjustment
	instanceVariableNames: 'selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-PDF'!

!TextBoxesAdjustment commentStamp: 'EP 3/7/2018 21:38' prior: 0!
A PDF-rendering post processor that adjusts the text boxes array by having it perform a given selector!

!TextBoxesAdjustment methodsFor: 'accessing' stamp: 'EP 3/7/2018 21:39'!
allButLast
	self selector: #allButLast! !

!TextBoxesAdjustment methodsFor: 'accessing' stamp: 'EP 3/7/2018 21:39'!
initialize
	super initialize.
	self selector: #yourself! !

!TextBoxesAdjustment methodsFor: 'evaluating' stamp: 'EP 3/7/2018 21:35'!
run: aTextBoxHolder 
	aTextBoxHolder textboxes: (aTextBoxHolder textboxes perform: self selector)! !

!TextBoxesAdjustment methodsFor: 'accessing' stamp: 'EP 3/7/2018 21:36'!
selector
	^ selector! !

!TextBoxesAdjustment methodsFor: 'accessing' stamp: 'EP 3/7/2018 21:38'!
selector: aSymbol 
	selector := aSymbol! !

!Number methodsFor: '*peldan-pdf' stamp: 'EP 3/3/2018 11:16'!
asPdfOffsetPoint
	^ self negated @ 0! !

!Number methodsFor: '*peldan-pdf' stamp: 'EP 3/3/2018 11:09'!
asPdfShowArgOn: aTarget 
	aTarget textPosition: self! !

!Number methodsFor: '*peldan-pdf' stamp: 'EP 2/24/2018 12:47'!
pdfNumberValueFor: anXrefHolder 
	^ self! !

NumberParser subclass: #IntegerParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Peldan-parsing'!

!IntegerParser methodsFor: 'accessing' stamp: 'EP 2/18/2018 09:44'!
allowPlusSign
	^ false! !

!IntegerParser methodsFor: 'parsing-public' stamp: 'EP 2/18/2018 09:43'!
nextNumber
	^ self nextInteger! !

!PositionableStream methodsFor: '*peldan-parsing' stamp: 'EP 2/28/2018 12:53'!
appendPdfIdPairTo: aLinkedList 
	| id |
	self next: '/ID' size.
	self maybeReadWhitespace.
	self readString: '['.
	id := self upTo: $].
	aLinkedList add: 'ID';
		 add: id! !

!PositionableStream methodsFor: '*peldan-parsing' stamp: 'EP 2/21/2018 22:30'!
appendPdfKeyValuePairsTo: aLinkedList
	(self peekForString: '/ID')
		ifTrue: [self appendPdfIdPairTo: aLinkedList];
		
		ifFalse: [self appendPdfStandardKeyValuePairTo: aLinkedList]! !

!PositionableStream methodsFor: '*peldan-parsing' stamp: 'EP 2/22/2018 21:04'!
appendPdfStandardKeyValuePairTo: aLinkedList 
	| key value |
	key := self readPdfDictionaryKey.
	self readWhitespace.
	value := self readPdfDictionaryValue.
	value
		ifNil: [self error: 'Expected PDF dictionary value'].
	aLinkedList add: key;
		 add: value! !

!PositionableStream methodsFor: '*peldan-parsing' stamp: 'EP 2/18/2018 19:55'!
asPdf
	^ PDFParser on: self! !

!PositionableStream methodsFor: '*peldan-parsing' stamp: 'EP 3/2/2018 17:27'!
back: anInteger 
	anInteger timesRepeat: [self back]! !

!PositionableStream methodsFor: '*peldan-parsing' stamp: 'ErikPeldan 2/16/2018 17:25'!
goBack: anInteger 
	self position: self position - anInteger.
	^ self! !

!PositionableStream methodsFor: '*peldan-parsing' stamp: 'EP 3/9/2018 22:37'!
maybeReadWhitespace
	self ascii.
	(self atEnd or: [self peek isWhitespace not])
		ifTrue: [^ false].
	self readWhitespace.
	^ true! !

!PositionableStream methodsFor: '*peldan-samples' stamp: 'ErikPeldan 2/16/2018 17:20'!
peek: anInteger 
	| p x |
	p := self position.
	x := self next: anInteger .
	self position: p.
	^ x! !

!PositionableStream methodsFor: '*peldan-parsing' stamp: 'EP 2/25/2018 17:25'!
peekForString: aString 
	| b p |
	self ascii.
	p := self position.
	b := (self next: aString size)
				= aString.
	self position: p.
	^ b! !

!PositionableStream methodsFor: '*peldan-parsing' stamp: 'ErikPeldan 2/15/2018 22:16'!
readLine
	^ self isBinary
		ifTrue: [ self upTo: Character cr asciiValue ];
		ifFalse: [ self upTo: Character lf ]! !

!PositionableStream methodsFor: '*peldan-parsing' stamp: 'EP 2/21/2018 22:25'!
readNonWhitespace
	self ascii.
	self peek isWhitespace not
		ifFalse: [self error: 'Expected non-whitespace'].
	[self peek isWhitespace not]
		whileTrue: [self next]! !

!PositionableStream methodsFor: '*peldan-parsing' stamp: 'ErikPeldan 2/15/2018 22:16'!
readNumber
	self ascii.
	^ NumberParser parse: self.! !

!PositionableStream methodsFor: '*peldan-parsing' stamp: 'EP 2/22/2018 21:10'!
readPdfDictionary
	| d |
	self readString: '<<'.
	d := self readPdfDictionaryKeyValuePairs.
	self readString: '>>'.
	"Transcript showln: self position asString , ' is end of dict'."
	^ d! !

!PositionableStream methodsFor: '*peldan-parsing' stamp: 'ErikPeldan 2/16/2018 16:25'!
readPdfDictionaryKey
 ^ self
		ascii;
		readString: '/';
		upTo: Character space.
		! !

!PositionableStream methodsFor: '*peldan-parsing' stamp: 'EPE 3/16/2018 22:13'!
readPdfDictionaryKeyValuePairs
	| pairs |
	self peek = Character cr
		ifTrue: [ self error: 'Expected to not start at line break' ].
	pairs := LinkedList new: 0.
	[ self maybeReadWhitespace. self peek ~= $> ]
		whileTrue: [ | key value |
			key := self readPdfDictionaryKey.
			value := self readPdfDictionaryValue.
			pairs
				add: key;
				add: value ].
	^ Dictionary newFromPairs: pairs! !

!PositionableStream methodsFor: '*peldan-parsing' stamp: 'EP 2/24/2018 13:11'!
readPdfDictionaryValue
	^ PDFParser parseContent: self! !

!PositionableStream methodsFor: '*peldan-parsing' stamp: 'ErikPeldan 2/16/2018 17:10'!
readPdfSpaceCr
	self readString: Character space asString , Character cr asString! !

!PositionableStream methodsFor: '*peldan-parsing' stamp: 'EP 2/23/2018 21:44'!
readPdfStreamObject
	| contents |
	self readString: 'stream'.
	(self peekForString: Character cr asString)
		ifTrue: [self next].
	self readString: Character lf asString.
	self binary.
	contents := self upToAll: (Character lf asString, 'endstream') asByteArray.
	self ascii.
	self halt.
	"Transcript showln: 'Stream read.'."
	^ contents! !

!PositionableStream methodsFor: '*peldan-parsing' stamp: 'ErikPeldan 2/16/2018 17:22'!
readSpaces
	[ self peek = Character space ] whileTrue: [ self next ]! !

!PositionableStream methodsFor: '*peldan-parsing' stamp: 'ErikPeldan 2/16/2018 16:50'!
readString: aString
	| s |
	s := self next: aString size.
	s = aString
		ifFalse: [ self
				position: self position - 1;
				error: 'Expected string ' , aString surroundedBySingleQuotes, ', not ', s surroundedBySingleQuotes  ].
	^ self! !

!PositionableStream methodsFor: '*peldan-parsing' stamp: 'EP 3/9/2018 22:36'!
readWhitespace
	self ascii.
	(self atEnd or: [self peek isWhitespace not])
		ifTrue: [self error: 'Expected whitespace'].
	[self atEnd not and: [self peek isWhitespace]]
		whileTrue: [self next]! !

!PositionableStream methodsFor: '*peldan-parsing' stamp: 'EP 3/9/2018 22:17'!
upToAnySatisfying: aBlockClosure 
	"Read items from the receiver until 'aBlockClosure value: item' return true
	Returns the items read. The new position of the receiver will be just before the item that stopped the reading"
	| c w |
	w := WriteStream on: (Array new: 100).
	[c := self next.
	(aBlockClosure value: c)
		ifTrue: [self back. ^ w contents]
		ifFalse: [w nextPut: c].
	self atEnd] whileFalse.
	^ w contents! !

!SimpleButtonMorph methodsFor: '*peldan-random' stamp: 'EP 2/21/2018 19:18'!
stream
	^ (self ownerThatIsA: StreamHolderMorph) stream! !

!SimpleButtonMorph methodsFor: '*peldan-random' stamp: 'EP 2/21/2018 19:18'!
streamPerform: aSelector
	^ self stream perform: aSelector! !

!SimpleButtonMorph methodsFor: '*peldan-random' stamp: 'EP 2/19/2018 22:19'!
targetSamplePdfStream
	^ self target: Samples samplePdfFileStream! !
